#include <gtk/gtk.h>
#define __USE_BSD
#include <math.h>
#include <stdlib.h>
#include "graph.h"

#define NUM 128

int main(int argc, char *argv[]){
  GtkWidget *window, *canvas;
  double *x1, *y1, *x2, *y2, *val;

  gtk_init(&argc, &argv);
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  canvas = my_contour();
  set_c_range(canvas, 0, 2, 0);
  set_c_range(canvas, 0, 2, 1);
  set_c_range(canvas, -7, 7, 2);
  set_c_label(canvas, "横軸", 0);
  set_c_label(canvas, "縦軸", 1);

  x1 = (double *) malloc(sizeof(double) * NUM*NUM);
  y1 = (double *) malloc(sizeof(double) * NUM*NUM);
  x2 = (double *) malloc(sizeof(double) * NUM*NUM);
  y2 = (double *) malloc(sizeof(double) * NUM*NUM);
  val = (double *) malloc(sizeof(double) * NUM*NUM);
  for(int ix = 0; ix < NUM; ix++){
    double xx1, xx2;
    xx1 = 2.0/NUM*ix;
    xx2 =  2.0/NUM*(ix+1);
    for(int iy = 0; iy < NUM; iy++){
      double yy1, yy2;
      yy1 = 2.0/NUM*iy;
      yy2 = 2.0/NUM*(iy+1);
      *(x1 + ix*NUM + iy) = xx1;
      *(y1 + ix*NUM + iy) = yy1;
      *(x2 + ix*NUM + iy) = xx2;
      *(y2 + ix*NUM + iy) = yy2;
      *(val + ix*NUM + iy) = exp((yy2+yy1)/2)*cos(2*M_PI*(xx1+xx2)/2);
    }
  }
  set_c_values(canvas, x1, y1, x2, y2, val, NUM*NUM);
  gtk_container_add(GTK_CONTAINER(window), canvas);
  gtk_widget_show_all(window);
  gtk_main();
}
