#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <complex.h>

#include <gtdispc.h>


void for_all_direction(char* filename){
  const int division = 600;
  double min_k, max_k;
  FILE *fpw, *fpr, *fph1, *fph2, *fph3, *fph4, *fph5, *fph6;
  char text[1024];
  int nline;
  double wavenum, freq, growth;
  complex h1, h2, h3, h4, h5, h6;
  double pre_freq, pre_growth;
  complex pre_h1, pre_h2, pre_h3, pre_h4, pre_h5, pre_h6;
  long int n_wavenum, pre_nwavenum;
  double *c_freq, *c_growth;
  complex *c_h1, *c_h2, *c_h3, *c_h4, *c_h5, *c_h6;
  double deltak;
  char filenamew[1024], filenamer[1024], filenameh1[1024], filenameh2[1024], filenameh3[1024], filenameh4[1024], filenameh5[1024], filenameh6[1024];

  // process inputs
  min_k = xcs;
  max_k = xcl;

  snprintf(filenamew, 1023, "%s_w.txt", filename);
  snprintf(filenamer, 1023, "%s_r.txt", filename);
  snprintf(filenameh1, 1023, "%s_h1.txt", filename);
  snprintf(filenameh2, 1023, "%s_h2.txt", filename);
  snprintf(filenameh3, 1023, "%s_h3.txt", filename);
  snprintf(filenameh4, 1023, "%s_h4.txt", filename);
  snprintf(filenameh5, 1023, "%s_h5.txt", filename);
  snprintf(filenameh6, 1023, "%s_h6.txt", filename);
  fpw = fopen(filenamew, "w");
  fpr = fopen(filenamer, "w");
  fph1 = fopen(filenameh1, "w");
  fph2 = fopen(filenameh2, "w");
  fph3 = fopen(filenameh3, "w");
  fph4 = fopen(filenameh4, "w");
  fph5 = fopen(filenameh5, "w");
  fph6 = fopen(filenameh6, "w");

  if(fpw == NULL || fpr == NULL || fph1 == NULL || fph2 == NULL || fph3 == NULL || fph4 == NULL || fph5 == NULL || fph6 == NULL){
    printf("The file %s cannot be opened\n", filename);
    return;
  }

  deltak = (max_k - min_k)/(division - 1);
  /*
  for(int i = 0; i < division; i++) fprintf(fpr, "%f\t", min_k + i*deltak);
  fprintf(fpr, "\n");
  for(int i = 0; i < division; i++) fprintf(fpw, "%f\t", min_k + i*deltak);
  fprintf(fpw, "\n");
  for(int i = 0; i < division; i++) fprintf(fpp, "%f\t", min_k + i*deltak);
  fprintf(fpp, "\n");
  for(int i = 0; i < division; i++) fprintf(fppoy_x, "%f\t", min_k + i*deltak);
  fprintf(fppoy_x, "\n");
  for(int i = 0; i < division; i++) fprintf(fppoy_y, "%f\t", min_k + i*deltak);
  fprintf(fppoy_y, "\n");
  for(int i = 0; i < division; i++) fprintf(fppoy_z, "%f\t", min_k + i*deltak);
  fprintf(fppoy_z, "\n");
  */

  c_freq    = (double *) malloc(sizeof(double) * division);
  c_growth    = (double *) malloc(sizeof(double) * division);
  c_h1    = (complex *) malloc(sizeof(complex) * division);
  c_h2    = (complex *) malloc(sizeof(complex) * division);
  c_h3    = (complex *) malloc(sizeof(complex) * division);
  c_h4    = (complex *) malloc(sizeof(complex) * division);
  c_h5    = (complex *) malloc(sizeof(complex) * division);
  c_h6    = (complex *) malloc(sizeof(complex) * division);

  // start reading
  for(int itheta = 0; itheta <= 90; itheta += 1){
    theta = itheta;
    calculate_unit();
    get_basic_parameters();
    ans = wkinit_v(theta);
    ans = wkcurv_v(ans, theta);

    for(int i = 0; i < division; i++) *(c_freq + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_growth + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_h1 + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_h2 + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_h3 + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_h4 + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_h5 + i) = -DBL_MAX;
    for(int i = 0; i < division; i++) *(c_h6 + i) = -DBL_MAX;

    for(int iline = 0; iline < ans; iline++){
      pre_nwavenum = -1;
      for(int j = 0; j < 200; j++){
        if(*(rrr[iline] + j) != -DBL_MAX);
        else {
          classify(rrr[iline], fff[iline], ddd1[iline], ddd2[iline], ddd3[iline], ddd4[iline], ddd5[iline], ddd6[iline], polarity[iline], poynting_x[iline], poynting_y[iline], poynting_z[iline], j);
          break;
        }
        if(j == 199){
          classify(rrr[iline], fff[iline], ddd1[iline], ddd2[iline], ddd3[iline], ddd4[iline], ddd5[iline], ddd6[iline], polarity[iline], poynting_x[iline], poynting_y[iline], poynting_z[iline], 200);
        }
      }
      for(int j = 0; j < 200; j++){
        wavenum = *(rrr[iline] + j);
        if(wavenum == -DBL_MAX) break;
        else{
          complex fct1, fct2;
          freq = creal(*(fff[iline] + j));
          growth = cimag(*(fff[iline] + j));
          fct1 = fabs(wc)/(freq + I*growth);
          fct2 = fct1*fct1;
          h1 = *(ddd1[iline] + j);
          h2 = *(ddd2[iline] + j)*fct1;
          h3 = *(ddd3[iline] + j)*fct1;
          h4 = *(ddd4[iline] + j)*fct2;
          h5 = *(ddd5[iline] + j)*fct2;
          h6 = *(ddd6[iline] + j)*fct2;

          n_wavenum = lround((wavenum - min_k)/deltak);
          if(n_wavenum < 0 || n_wavenum > division -1) continue;
          if(pre_nwavenum < 0){
            ; // do nothing here
          }else{
            for(int i = pre_nwavenum + 1; i <= n_wavenum; i++){
              double p_freq, p_growth;
              complex p_h1, p_h2, p_h3, p_h4, p_h5, p_h6;
              p_freq = (freq - pre_freq)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_freq;
              p_growth = (growth - pre_growth)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_growth;
              p_h1 = (h1 - pre_h1)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_h1;
              p_h2 = (h2 - pre_h2)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_h2;
              p_h3 = (h3 - pre_h3)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_h3;
              p_h4 = (h4 - pre_h4)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_h4;
              p_h5 = (h5 - pre_h5)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_h5;
              p_h6 = (h6 - pre_h6)/(n_wavenum - pre_nwavenum)*(i - pre_nwavenum) + pre_h6;
              if(*(c_growth + i) < p_growth && p_freq >= 0.25 && p_freq < 1){
                *(c_growth + i) = p_growth;
                *(c_freq + i) = p_freq;
                *(c_h1 + i) = p_h1;
                *(c_h2 + i) = p_h2;
                *(c_h3 + i) = p_h3;
                *(c_h4 + i) = p_h4;
                *(c_h5 + i) = p_h5;
                *(c_h6 + i) = p_h6;
              }
            }
          }
          pre_nwavenum = n_wavenum;
          pre_freq = freq;
          pre_growth = growth;
          pre_h1 = h1;
          pre_h2 = h2;
          pre_h3 = h3;
          pre_h4 = h4;
          pre_h5 = h5;
          pre_h6 = h6;
        }
      }
    }
    for(int i = 0; i < division; i++) fprintf(fpr, "%e\t", *(c_growth + i));
    fprintf(fpr, "\n");
    for(int i = 0; i < division; i++) fprintf(fpw, "%e\t", *(c_freq + i));
    fprintf(fpw, "\n");
    for(int i = 0; i < division; i++) fprintf(fph1, "%e\t%e\t", creal(*(c_h1+i)), cimag(*(c_h1+i)));
    fprintf(fph1, "\n");
    for(int i = 0; i < division; i++) fprintf(fph2, "%e\t%e\t", creal(*(c_h2+i)), cimag(*(c_h2+i)));
    fprintf(fph2, "\n");
    for(int i = 0; i < division; i++) fprintf(fph3, "%e\t%e\t", creal(*(c_h3+i)), cimag(*(c_h3+i)));
    fprintf(fph3, "\n");
    for(int i = 0; i < division; i++) fprintf(fph4, "%e\t%e\t", creal(*(c_h4+i)), cimag(*(c_h4+i)));
    fprintf(fph4, "\n");
    for(int i = 0; i < division; i++) fprintf(fph5, "%e\t%e\t", creal(*(c_h5+i)), cimag(*(c_h5+i)));
    fprintf(fph5, "\n");
    for(int i = 0; i < division; i++) fprintf(fph6, "%e\t%e\t", creal(*(c_h6+i)), cimag(*(c_h6+i)));
    fprintf(fph6, "\n");
    if(itheta%10 == 0) printf("%d deg ended\n", itheta);
  }
  fclose(fpw);
  fclose(fpr);
  fclose(fph1);
  fclose(fph2);
  fclose(fph3);
  fclose(fph4);
  fclose(fph5);
  fclose(fph6);
  free(c_growth);
  free(c_freq);
  free(c_h1);
  free(c_h2);
  free(c_h3);
  free(c_h4);
  free(c_h5);
  free(c_h6);
}

