#include <gtk/gtk.h>
#include <stdlib.h>
#include <gtdispc.h>
#include <math.h>
#include <complex.h>
#include "graph.h"
#include "state.h"

static check(complex *pp, complex *pm, complex *mp, complex *mm, complex f, complex val){
  if(creal(val) > 0){
    if(cimag(val) > 0) *pp = f;
    else *pm = f;
  }else{
    if(cimag(val) > 0) *mp = f;
    else *mm = f;
  }
}

static gboolean cb_button_press_event(GtkWidget *w, GdkEventButton *event, gpointer p){
  double x,y;
  get_click(w, &x, &y);

  complex f,f2, h,h2;
  double thr, yr, yi;
  double dx = unit*1e6;
  complex fhistory[101];
  double dhistory[101];
  complex pp, pm, mp, mm;
  int ic;
  ic = 0;
  f = x + I*y;
  fhistory[0] = f;
  dhistory[0] = 1;
  ic++;
  thr = theta/180*M_PI;
  yr = xcs*sin(thr);
  yi = xcs*cos(thr);
  bessmd(yr);
  f2 = f - dx;
  h2 = htodh(f2, yr, yi);
  while(1)
  {
    complex dh, df;
    double fabss;
    const double fabmin = 1e-3;
    const double fl2 = 1e37;
    const int icmax = 100;
    if(ic < 50){
      h = htodh(f, yr, yi);
      //if(cabs(h) < 1e5) break;
      dh = (h - h2)/(f - f2);
      df = h/dh;
      h2 = h;
      f2 = f;
      f -= df;
      fhistory[ic] = f;
      dhistory[ic] = cabs(df)/fabss;
      // converge?
      fabss = cabs(f) > fabmin ? cabs(f) : fabmin;
      if(fabs(creal(h)) + fabs(cimag(h)) > fl2){
        g_message("not converge");
        break;
      }
      if(cabs(df)/fabss <= 1e-7 && ic != 0){
        g_message("iteration %d converge to %e %eI", ic, creal(f), cimag(f));
        break;
      }
      if(ic > icmax){
        g_message("not converge");
        break;
      }
    }else{
      if(ic == 50){// initialize
        complex df_pre;
        double accel;
        complex ff1, ff2, ff3, ff4;
        complex hh1, hh2, hh3, hh4;
        df_pre = f - f2;
        ff1 = f;
        hh1 = htodh(ff1, yr, yi);
        //if(cabs(h) < 1e5) break;
        dh = (hh1 - h2)/(ff1 - f2);
        df = hh1/dh;
        accel = cabs(df_pre)/cabs(df);
        g_message("%lf %lf\n", creal(df), cimag(df));
        while(1){
          accel *= 2;
          ff2 = ff1 - accel*df;
          hh2 = htodh(ff2, yr, yi);
          if( creal(hh1) *creal(hh2) < 0 && cimag(hh1) *cimag(hh2) < 0)break;

          if(ic > 100) break;
          ic++;
        }
        ff3 = (ff2 - ff1)*I/2 + (ff1+ff2*accel)/(1+accel); 
        ff4 = -(ff2 - ff1)*I/2 + (ff1+ff2*accel)/(1+accel); 
        hh3 = htodh(ff3, yr, yi);
        hh4 = htodh(ff4, yr, yi);
        pp = 0; pm = 0; mp = 0; mm = 0;
        check(&pp, &pm, &mp, &mm, ff1, hh1);
        check(&pp, &pm, &mp, &mm, ff2, hh2);
        check(&pp, &pm, &mp, &mm, ff3, hh3);
        check(&pp, &pm, &mp, &mm, ff4, hh4);
        g_message("aaaa");
        g_message("%lf\n", accel);
        g_message("%lf %lf\n", creal(hh1), cimag(hh1));
        g_message("%lf %lf\n", creal(hh2), cimag(hh2));
        g_message("%lf %lf\n", creal(hh3), cimag(hh3));
        g_message("%lf %lf\n", creal(hh4), cimag(hh4));
        g_message("ffff");
        g_message("%lf %lf\n", creal(ff1), cimag(ff1));
        g_message("%lf %lf\n", creal(ff2), cimag(ff2));
        g_message("%lf %lf\n", creal(ff3), cimag(ff3));
        g_message("%lf %lf\n", creal(ff4), cimag(ff4));
        if(pp == 0 || pm == 0 || mp == 0 || mm == 0){
          g_message("not converge at bisection");
          break;
        }
      }else if(ic < 100){
        complex next, nexth;
        double ddf;
        next = (pp + mp)/2;
        nexth = htodh(next, yr, yi);
        check(&pp, &pm, &mp, &mm, next, nexth);
        next = (mp + mm)/2;
        nexth = htodh(next, yr, yi);
        check(&pp, &pm, &mp, &mm, next, nexth);
        next = (mm + pm)/2;
        nexth = htodh(next, yr, yi);
        check(&pp, &pm, &mp, &mm, next, nexth);
        next = (pm + pp)/2;
        nexth = htodh(next, yr, yi);
        check(&pp, &pm, &mp, &mm, next, nexth);
        fabss = cabs(f) > fabmin ? cabs(f) : fabmin;
        ddf = cabs(mp - pm) > cabs(pp -mm) ? cabs(mp - pm) : cabs(pp - mm);
        if(ddf/fabss <= 1e-7){
          double conv;
          conv = (pm + mm + mp + pp)/4;
          g_message("iteration %d converge to %e %eI", ic, creal(conv), cimag(conv));
          break;
        }
      }else{
        g_message("fail");
        break;
      }
      ic += 3;
    }
    ic++;
  }

  FILE *fp;
  fp = fopen("trajectry.txt","w");
  for(int i = 0; i < ic; i++) fprintf(fp, "%e\t%e\t%e\n", creal(fhistory[i]), cimag(fhistory[i]), dhistory[i]);
  fclose(fp);
  htodhd(f,yr,yi);
  return FALSE;
}

static void cb_convergence(GtkWidget *w, GtkWindow *window){
  double thr, yr, yi;
  complex h_val[40000];
  int ic_val[40000];
  FILE *fp;
  // calculate the table of H
  thr = theta/180*M_PI;
  yr = xcs*sin(thr);
  yi = xcs*cos(thr);
  bessmd(yr);

  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++){
      double  x, y;
      complex f, f2, h2, h;
      const double dx = unit*1e6;
      int ic;
      ic = 0;
      x = (cxa - cxi)/199*iw + cxi;
      y = (cya - cyi)/199*ig + cyi;
      f = x + I*y;
      f2 = f - dx;
      h2 = htodh(f2, yr, yi);
      while(1)
      {
        complex dh, df;
        double fabss;
        const double fabmin = 1e-3;
        const double fl2 = 1e37;
        const int icmax = 100;
        h = htodh(f, yr, yi);
        //if(cabs(h) < 1e5) break;
        dh = (h - h2)/(f - f2);
        df = h/dh;
        h2 = h;
        f2 = f;
        f -= df;
        // converge?
        fabss = cabs(f) > fabmin ? cabs(f) : fabmin;
        if(fabs(creal(h)) + fabs(cimag(h)) > fl2){
          h_val[iw*200 + ig] = DBL_MAX + I*DBL_MAX;
          break;
        }
        if(cabs(df)/fabss <= 1e-7 && ic != 0){
          h_val[iw*200 + ig] = f;
          break;
        }
        if(ic > icmax){
          h_val[iw*200 + ig] = -DBL_MAX - I*DBL_MAX;
          break;
        }
        ic++;
      }
      ic_val[iw*200+ig] = ic;
    }
  }

  fp = fopen("convergence_w.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fp, "%e\t", creal(h_val[iw*200 + ig]));
    fprintf(fp, "\n");
  }
  fclose(fp);

  fp = fopen("convergence_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fp, "%e\t", cimag(h_val[iw*200 + ig]));
    fprintf(fp, "\n");
  }
  fclose(fp);

  fp = fopen("convergence_c.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fp, "%d\t", ic_val[iw*200 + ig]);
    fprintf(fp, "\n");
  }
  fclose(fp);

}

static void cb_determinant(GtkWidget *w, GtkWindow *window){
  double thr, yr, yi;
  complex h_val[40000];
  complex h1[40000], h2[40000], h3[40000], h4[40000], h5[40000], h6[40000];
  complex *hhdd;
  FILE *fp, *fpw, *fpr;
  // calculate the table of H
  thr = theta/180*M_PI;
  yr = xcs*sin(thr);
  yi = xcs*cos(thr);
  bessmd(yr);
  hhdd = (complex *) malloc(sizeof(complex)*40000*num*6);
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++){
      double  x, y;
      x = (cxa - cxi)/199*iw + cxi;
      y = (cya - cyi)/199*ig + cyi;
      h_val[iw*200 + ig] = htodh2(x+I*y, yr, yi);
      h1[200*iw + ig] = dddd1;
      h2[200*iw + ig] = dddd2;
      h3[200*iw + ig] = dddd3;
      h4[200*iw + ig] = dddd4;
      h5[200*iw + ig] = dddd5;
      h6[200*iw + ig] = dddd6;
      for(int inum = 0; inum < num; inum++){
        *(hhdd + 40000*6*inum + 40000*0 + 200*iw + ig) = *(hhhh1 + inum);
        *(hhdd + 40000*6*inum + 40000*1 + 200*iw + ig) = *(hhhh2 + inum);
        *(hhdd + 40000*6*inum + 40000*2 + 200*iw + ig) = *(hhhh3 + inum);
        *(hhdd + 40000*6*inum + 40000*3 + 200*iw + ig) = *(hhhh4 + inum);
        *(hhdd + 40000*6*inum + 40000*4 + 200*iw + ig) = *(hhhh5 + inum);
        *(hhdd + 40000*6*inum + 40000*5 + 200*iw + ig) = *(hhhh6 + inum);
      }
    }
  }

  fp = fopen("determinant_w.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fp, "%e\t", creal(h_val[iw*200 + ig]));
    fprintf(fp, "\n");
  }
  fclose(fp);

  fp = fopen("determinant_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fp, "%e\t", cimag(h_val[iw*200 + ig]));
    fprintf(fp, "\n");
  }
  fclose(fp);

  fpw = fopen("h1_w.txt", "w");
  fpr = fopen("h1_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h1[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h1[iw*200 + ig]));
    fprintf(fp, "\n");
  }
  fclose(fpw);
  fclose(fpr);

  fpw = fopen("h1_w.txt", "w");
  fpr = fopen("h1_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h1[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h1[iw*200 + ig]));
    fprintf(fpw, "\n");
    fprintf(fpr, "\n");
  }
  fclose(fpw);
  fclose(fpr);

  fpw = fopen("h2_w.txt", "w");
  fpr = fopen("h2_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h2[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h2[iw*200 + ig]));
    fprintf(fpw, "\n");
    fprintf(fpr, "\n");
  }
  fclose(fpw);
  fclose(fpr);

  fpw = fopen("h3_w.txt", "w");
  fpr = fopen("h3_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h3[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h3[iw*200 + ig]));
    fprintf(fpw, "\n");
    fprintf(fpr, "\n");
  }
  fclose(fpw);
  fclose(fpr);

  fpw = fopen("h4_w.txt", "w");
  fpr = fopen("h4_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h4[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h4[iw*200 + ig]));
    fprintf(fpw, "\n");
    fprintf(fpr, "\n");
  }
  fclose(fpw);
  fclose(fpr);

  fpw = fopen("h5_w.txt", "w");
  fpr = fopen("h5_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h5[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h5[iw*200 + ig]));
    fprintf(fpw, "\n");
    fprintf(fpr, "\n");
  }
  fclose(fpw);
  fclose(fpr);

  fpw = fopen("h6_w.txt", "w");
  fpr = fopen("h6_r.txt", "w");
  for(int iw = 0; iw < 200; iw++){
    for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(h6[iw*200 + ig]));
    for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(h6[iw*200 + ig]));
    fprintf(fpw, "\n");
    fprintf(fpr, "\n");
  }
  fclose(fpw);
  fclose(fpr);
  for(int inum = 0; inum < num; inum++){
    for(int ih = 0; ih < 6; ih++){
      char text[100];
      FILE *fpw, *fpr;
      snprintf(text, 99, "h%d_%d_w.txt", ih+1, inum+1);
      fpw = fopen(text, "w");
      snprintf(text, 99, "h%d_%d_r.txt", ih+1, inum+1);
      fpr = fopen(text, "w");
      for(int iw = 0; iw < 200; iw++){
        for(int ig = 0; ig < 200; ig++) fprintf(fpw,"%e\t", creal(*(hhdd + 40000*6*inum + 40000*ih + 200*iw + ig)));
        for(int ig = 0; ig < 200; ig++) fprintf(fpr,"%e\t", cimag(*(hhdd + 40000*6*inum + 40000*ih + 200*iw + ig)));
        fprintf(fpw, "\n");
        fprintf(fpr, "\n");
      }
      fclose(fpw);
      fclose(fpr);
    }
  }
  free(hhdd);
}


GtkWidget * main2_new(double *x1, double *y1, double *x2, double *y2, double *h_val, int length){
  GtkWidget *win, *Contour;
  GtkWidget *hbox, *vbox;
  GtkWidget *button;
  win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal(GTK_WINDOW(win), FALSE);
  Contour = my_contour();
  set_c_values(Contour, x1, y1, x2, y2, h_val, length);
  set_c_range(Contour, cxi, cxa, 0);
  set_c_range(Contour, cyi, cya, 1);
  set_c_range(Contour, 15, 25, 2);
  gtk_widget_set_size_request(GTK_WIDGET(Contour), 500, 500);

  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add(GTK_CONTAINER(win), vbox);

  gtk_box_pack_start_defaults(GTK_BOX(vbox), Contour);

  hbox = gtk_hbox_new(TRUE, 2);
  gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);

  button = gtk_button_new_with_label("Determinant");
  gtk_box_pack_start_defaults(GTK_BOX(hbox), button);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_determinant), NULL);

  button = gtk_button_new_with_label("Convergence");
  gtk_box_pack_start_defaults(GTK_BOX(hbox), button);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_convergence), NULL);

  gtk_widget_add_events(Contour, GDK_BUTTON_PRESS_MASK);
  g_signal_connect(G_OBJECT(Contour), "button-press-event", G_CALLBACK(cb_button_press_event), NULL);
  
  return win;
}
