#include <complex.h>

extern double wc;        // cyclotron freq of the first component
extern double cv;        // speed of light
extern int num;          // the number of kinds of atoms

extern double *an;       // charge
extern double *wpd;      // plasma freq when >0 or relative dencity
extern double *qm;       // charge over mass
extern double *peth;     // perpendicular thermal velocity sqrt(kbT/m)
extern double *path;     // parallel thermal velocity
extern double *spa;      // parallel drift velocity ?
extern int *loss0;       // 0 bi-Maxwellian 1 loss-cone of AK
extern double *bfac;     // beta of AK
extern double *ppp;      // rho of AK

extern double *ran;      // relative charge *sign is reserved
extern double *rm;       // relative mass
extern double *rn;       // relative dencity
extern double *wp;       // plasma freq
extern double *t;        // relative perpendicular temperature
extern double *tr;       // temperature ratio
extern double *v;        // relative drift velocity
extern double *closs1;   // coefficient for the adding part of loss cone distribution
extern double *closs2;   // coefficient for the subtracting part of loss cone distribution
extern int *kappa;       // kappa for kappa-maxwellian distribution

extern double yne;       // squared plasma parameter(PI/omega) for the 1st component
extern double ylri;      // Larmor radius of the first component
extern double c;         // ratio between c and *peth
extern double b;         // strength of the magnetic field
extern double val;       // Alfven velocity

extern double theta;     // direction of wave propagation in degree

extern double unit;      // used for determing some thresholds


extern int ans; // number of solutions

#define NUM_BE 255
#define NUM_BE_MAX 240
extern double *be;       // scaled modified Bessel's function of the 1st kind
extern double *dbe;      // the derivative
extern double *benn;     // e(-x)I_j(x)/x/j/j
extern int *maxb;        // maximum index of available be-s

extern void initialize_parmeters(int num);

/*
This returns 0 if allocating memories is successful, otherwise it returns other than 0.
If parameters get unnecessary, you should free the memory allocated by this function by using ???.
*/
extern int get_basic_parameters(void);

/* i dont know what this is */
extern double dmach(void);
extern void calculate_unit(void);

/* create the table of Bessel's funcions, its first derivatives and ... */
extern int bessmd(double yx);

/* calculate complex error function*/
extern complex z(complex *z);

/* calculate plasma function and its first derivative */
extern void dspfn(complex *x, complex *z, complex *dz);

extern complex htodh(complex f1, double f2, double f3);
extern complex htodhd(complex f1, double f2, double f3); // for debug
extern complex htodh2(complex f1, double f2, double f3);

extern void search (double theta);

extern double xcs;
extern double xcl;
extern double xst;
extern double cxi;
extern double cxa;
extern double cyi;
extern double cya;

extern int load_geometry_from_file(char *filename);

extern double *contour_map;
//#define CONTOUR_WIDTH 16 // default 16
//#define CONTOUR_HEIGHT 8 // 2*n default 8

extern void write_contour_map(char *filename);

extern int wkinit(complex *f, double yr, double yi);

extern complex ff[200];
extern double rrkk[200];
extern complex dd1[200];
extern complex dd2[200];
extern complex dd3[200];
extern complex dd4[200];
extern complex dd5[200];
extern complex dd6[200];
extern int wkcurv(complex f, double rkw, double theta);

extern int nx, ny, nk;
extern int load_vgeometry_from_file(char *filename);

extern complex *fregn;
extern int wkregn(void);

// returns the number of converged answers
extern complex *fans;
extern double *rans;
extern int wkinit_v(double theta);

extern void sort_complex(complex *f, int num);

extern complex *fff[1000];
extern complex *ddd1[1000];
extern complex *ddd2[1000];
extern complex *ddd3[1000];
extern complex *ddd4[1000];
extern complex *ddd5[1000];
extern complex *ddd6[1000];
extern double *polarity[1000];
extern complex *eee_x[1000];
extern complex *eee_y[1000];
extern complex *eee_z[1000];

extern double *rrr[1000];
extern int wkcurv_v(int num, double theta);

#ifndef M_PI
#define M_PI 3.14159265358979323846246433832795
#endif

extern complex dddd1;
extern complex dddd2;
extern complex dddd3;
extern complex dddd4;
extern complex dddd5;
extern complex dddd6;

extern void classify(double *r, complex *f, complex *d1, complex *d2, complex *d3, complex *d4, complex *d5, complex *d6, double *pol, complex *e_x, complex *e_y, complex *e_z, int length);

extern void sort_cv(double *d, int length, int num, ...);



extern complex debugg;

extern complex *hhhh1;
extern complex *hhhh2;
extern complex *hhhh3;
extern complex *hhhh4;
extern complex *hhhh5;
extern complex *hhhh6;

complex zkm_int(int kappa, complex z);
complex zkmd_int(int kappa, complex z);
void create_kappa_table();
