#include <complex.h>
#include <math.h>
#include "gtdispc.h"

void classify(double *r, complex *f, complex *d1, complex *d2, complex *d3, complex *d4, complex *d5, complex *d6, double *pola, complex *e_x, complex *e_y, complex *e_z, int length){
  double fct1, fct2;
  complex A9, B9, C9, D9, E9, F9, G9, H9, I9;
  complex Hp1, Hp2, Hp3, Hp4, Hp5, Hp6;
  complex DDD[5][5];
  int nflag[4], iflag, jflag;
//-- CALCURATION OF MATRIX COMPONENT ------------------------------------
  for(int s = 0; s < length; s++){
    double si,c,s2, sc, c2;
    double t;
    fct1 = fabs(wc)/(*(f + s));
    fct2 = fct1*fct1;
    /* original codes
    A9 = *(d1 + s);
    B9 = I* *(d2 + s) *fct1;
    C9 = *(d3 + s)*fct1;
    D9 = -I* *(d2 + s) *fct1;
    E9 = *(d4 + s) *fct2;
    F9 = -I* *(d5 + s) *fct2;
    G9 = *(d3 + s) *fct1;
    H9 = *(d5 + s) *I*fct2;
    I9 = *(d6 + s) *fct2;
    */
    t = theta/180*M_PI;
    si = sin(t);
    c = cos(t);
    s2 = si*si;
    sc = si*c;
    c2 = c*c;
    Hp1 = *(d1 + s);
    Hp2 = *(d2 + s)*fct1;
    Hp3 = *(d3 + s)*fct1;
    Hp4 = *(d4 + s)*fct2;
    Hp5 = *(d5 + s)*fct2;
    Hp6 = *(d6 + s)*fct2;
//-- AXIS TRANSFER FOR KEMPO --------------------------------------------
    for(int i = 0; i<5; i++)
      for(int j = 0; j<5; j++) DDD[i][j] = 0;
    /* original codes
    DDD[1][1] = A9;
    DDD[1][2] = C9;
    DDD[1][3] =-B9;
    DDD[2][1] = D9;
    DDD[2][2] = F9;
    DDD[2][3] =-E9;
    DDD[3][1] = G9;
    DDD[3][2] = I9;
    DDD[3][3] =-H9;
    */
    DDD[1][1] = Hp1*s2 - 2*Hp3*sc + Hp6*c2;
    DDD[1][2] = I*(Hp2*si - Hp5*c);
    DDD[1][3] = Hp1*sc + Hp3*(s2 - c2) - Hp6*sc;
    DDD[2][1] = -DDD[1][2];
    DDD[2][2] = Hp4;
    DDD[2][3] = -I*(Hp2*c + Hp5*si);
    DDD[3][1] = DDD[1][3];
    DDD[3][2] = -DDD[2][3];
    DDD[3][3] = Hp1*c2 + 2*Hp3*sc + Hp6*s2;
//------ MATRIX CONVERSION --------------------------------------------------
    for(int i = 1; i <= 3;i++) nflag[i] = i;
    for(int npivot = 1; npivot<=2; npivot++){
      double ddmax;
      iflag = npivot;
      jflag = npivot;
    // find the maximum element
      ddmax = cabs(DDD[npivot][npivot]);
      for(int i = npivot; i <= 3; i++){
        for(int j = npivot; j <= 3; j++){
          if(cabs(DDD[i][j]) > ddmax){
            ddmax = cabs(DDD[i][j]);
            iflag = i;
            jflag = j;
          }
        }
      }
      // exchange rows or columns
      for(int  j=1; j <= 3; j++){
        DDD[4][j]      = DDD[iflag][j];
        DDD[iflag][j]  = DDD[npivot][j];
        DDD[npivot][j] = DDD[4][j];
       }
      for(int i = 1; i <= 3; i++){
        DDD[i][4]      = DDD[i][jflag];
        DDD[i][jflag]  = DDD[i][npivot];
        DDD[i][npivot] = DDD[i][4];
      }
      // normalize the npibot-th row
      for(int j = 3; j >= npivot; j--) DDD[npivot][j] = DDD[npivot][j]/DDD[npivot][npivot];
      // sweep out the npibot-th column
      for(int i = npivot+1; i <= 3; i++){
        complex pbuff;
        pbuff = DDD[i][npivot];
        for(int j = npivot; j <= 3; j++) DDD[i][j] = DDD[i][j] - DDD[npivot][j]*pbuff;
      }
      // reorder E
      int ibuff;
      ibuff = nflag[jflag];
      nflag[jflag] = nflag[npivot];
      nflag[npivot] = ibuff;
    }
//---- RELATION BETWEEN EACH COMPONENT OF E(B) VECTOR--------------------
    complex ctemp, pol[4];
    double tpol, Rc, Ac, Bc, Lmin2, Lmax2;
    pol[nflag[1]] = -DDD[1][3];
    pol[nflag[2]] = -DDD[2][3];
    pol[nflag[3]] = 1;
    //ctemp = (pol[1]*sin(-theta*1.745329252e-2) + pol[2]*cos(-theta*1.745329252e-2))/pol[3];
    if(cabs(pol[2]) < unit) *(pola + s) = 0;
    else{
      /*
      complex ccc;
      double ratio;
      ccc = pol[1]/pol[2];
      ratio = cabs(pol[2]) > cabs(pol[1]) ? cabs(pol[1])/cabs(pol[2]) : cabs(pol[2])/cabs(pol[1]);
      *(pola + s) = cimag(ccc)/cabs(ccc)*ratio;
      */
      double a, b, c;
      double alpha, beta, gamma;
      double A, B, C;
      double elp;
      double D,F;
      int sign;

      a = cabs(pol[1]);
      b = cabs(pol[2]);
      c = cabs(pol[3]);
      alpha = carg(pol[1]);
      beta = carg(pol[2]);
      gamma = carg(pol[3]);

      A = pow(a*cos(alpha),2) + pow(b*cos(beta), 2) + pow(c*cos(gamma), 2);
      B = -(a*a*sin(2*alpha) + b*b*sin(2*beta) + c*c*sin(2*gamma))/2;
      C = pow(a*sin(alpha),2) + pow(b*sin(beta), 2) + pow(c*sin(gamma), 2);

      D = sqrt(pow((A-C)/2,2) + B*B);
      F = (A+C)/2;
      elp = sqrt((F-D)/(F+D));

      sign = cimag(pol[1]/pol[2]) > 0 ? 1 : -1;
      sign = creal(*(f+s)) > 0 ? sign : -sign;

      *(pola + s) = elp*sign;
      *(e_x + s) = pol[1];
      *(e_y + s) = pol[2];
      *(e_z + s) = pol[3];
    }
    /* Calculation of direction of Poynting vector*/
  {
    double k_vector[4];
    complex b_vector[4]; // B vector
    complex cb_vector[4]; // conjugate
    complex p_vector[4];
    double angle, dtemp;
    double norm;
    angle = theta/180*M_PI;
    /*
    if(cabs(*(f+s)) < unit){
      *(p_x + s) = 0;
      *(p_y + s) = 0;
      *(p_z + s) = 0;
    }else{
      k_vector[1] = sin(angle);
      k_vector[2] = 0;
      k_vector[3] = cos(angle);
      b_vector[1] = (k_vector[2]*pol[3] - k_vector[3]*pol[2])/(*(f+s));
      b_vector[2] = (k_vector[3]*pol[1] - k_vector[1]*pol[3])/(*(f+s));
      b_vector[3] = (k_vector[1]*pol[2] - k_vector[2]*pol[1])/(*(f+s));
      cb_vector[1] = conj(b_vector[1]);
      cb_vector[2] = conj(b_vector[2]);
      cb_vector[3] = conj(b_vector[3]);
      p_vector[1] = pol[2]*cb_vector[3] - pol[3]*cb_vector[2];
      p_vector[2] = pol[3]*cb_vector[1] - pol[1]*cb_vector[3];
      p_vector[3] = pol[1]*cb_vector[2] - pol[2]*cb_vector[1];
      norm = sqrt(pow(creal(p_vector[1]),2) + pow(creal(p_vector[2]), 2) + pow(creal(p_vector[3]), 2));
      *(p_x + s) = creal(p_vector[1])/norm;
      *(p_y + s) = creal(p_vector[2])/norm;
      *(p_z + s) = creal(p_vector[3])/norm;
    }
    */
  }
    /*
    ctemp = (pol[1])/pol[2];
    tpol = atan2(cimag(ctemp),creal(ctemp));
    Rc = cabs(ctemp);
    Ac = Rc*Rc*cos(2*tpol)+1;
    Bc = Rc*Rc*sin(2*tpol);
    Lmin2 = (-sqrt(Ac*Ac+Bc*Bc) + Rc*Rc + 1)/2;
    Lmax2 = Lmin2 + sqrt(Ac*Ac + Bc*Bc);
    
    *(wave+s) = 0;
    if(creal(*(f+s)) < -cimag(*(f+s))/10 && cimag(*(f+s)) < 0) *(wave + s) += VANISH;
    if(Lmin2 < 0.01*Lmax2) *(wave + s) += POL_S;
//    if(tpol > 0) *(wave + s) += POL_L;
    if(creal(ctemp) < cimag(ctemp)) *(wave + s) += POL_L;
    else *(wave + s) += POL_R;
    */
  }
}
