#include <complex.h>
#include <math.h>

#include "gtdispc.h"

void dspfn(complex *x, complex *zz, complex *dz)
{
  double Rex, Imx, Remx2, aImx2;
  complex ctemp;
  Rex = creal(*x);
  Imx = cimag(*x);
  Remx2 = Imx*Imx - Rex*Rex; // real part of -x^2
  aImx2 = fabs(2*Rex*Imx); // absolute value of imaginary part of x^2
  if(Imx < 0 && (aImx2 >= 0.3e16 || Remx2 >= 86))
  {
    ctemp = 3e7 - 3e7*I;
    *zz = z(&ctemp);
  }
  else *zz = z(x);
  *dz = -2*(1 + *x* *zz);
}
