#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "gtdispc.h"

/*
  This program calculates some values used in KUPDAP.
  you must use this function before calculating the dispersion relation
*/

int get_basic_parameters(void)
{
  if(ran) free(ran);
  if(rm) free(rm);
  if(rn) free(rn);
  if(wp) free(wp);
  if(t) free(t);
  if(tr) free(tr);
  if(v) free(v);
  if(closs1) free(closs1);
  if(closs2) free(closs2);

  ran = (double *) malloc(sizeof(double)*num);
  rm = (double *) malloc(sizeof(double)*num);
  rn = (double *) malloc(sizeof(double)*num);
  wp = (double *) malloc(sizeof(double)*num);
  t = (double *) malloc(sizeof(double)*num);
  tr = (double *) malloc(sizeof(double)*num);
  v = (double *) malloc(sizeof(double)*num);
  closs1 = (double *) malloc(sizeof(double)*num);
  closs2 = (double *) malloc(sizeof(double)*num);

  if(ran == NULL || rm == NULL || rn == NULL || wp == NULL || t == NULL || tr == NULL || v == NULL || closs1 == NULL || closs2 == NULL)
  {
    printf("malloc failure\n");
    free(ran);
    free(rm);
    free(rn);
    free(wp);
    free(t);
    free(tr);
    free(v);
    free(closs1);
    free(closs2);
    free(kappa);
    return 1;
  }

  /* calculation of plasma parameters */
  for(int i = 0;i < num;i++)
  {
    *(ran + i) = *(an + i)/ fabs(*an); // you should regard ran as an
    *(rm + i) = fabs(*(ran + i)*(*qm)/ *(qm+i));
    if(*(wpd + i) > 0)
    {
      *(rn + i) = fabs(pow(*(wpd+i) /  *(ran+i) / *wpd, 2)* *(rm+i));
      *(wp + i) = *(wpd + i);
    }else
    {
      *(rn + i) = - *(wpd + i);
      *(wp + i) = sqrt(*(rn + i)/ *(rm + i)) * fabs(*(ran + i) * *wpd);
    }
    *(t + i) = *(rm + i)*pow(*(peth + i)/ *peth, 2);
    *(tr + i) = pow(*(peth + i)/ *(path + i), 2);
    *(v + i) = *(spa + i)/ *peth;
    *(closs1 + i) = 1/(1 - *(ppp + i)* *(bfac + i));
    *(closs2 + i) = - *(ppp + i)* *(bfac + i)/(1 - *(ppp + i)* *(bfac + i));
  }

  yne = pow(*wp/wc,2);
  ylri = *peth/fabs(wc);
  c = cv/ *peth;
  b = wc/ *qm;
  val = 0;
  for(int i = 0;i < num; i++)
  {
    if(*(qm + i) > 0) val += pow(*(wp+i)* *qm/wc/ *(qm + i), 2);
  }
  if(val != 0) val = cv/sqrt(val);

  return 0;
}
