#include <complex.h>
#include <stdio.h>
#include <math.h>

#include "gtdispc.h"

static void d_printf(char *c, complex a)
{
#ifdef DEBUG
  fprintf(stderr, "%s %e + I%e\n", c, creal(a), cimag(a));
#endif
}

int wkinit(complex *f,double yr,double yi)
{
  int ic = 0;
  int const icmax = 100;
  complex f2, h2;

  f2 = *f - unit*1e6;
  h2 = htodh(f2, yr, yi);
  while(1)
  {
    //const double fl1 = 1e-37;
    const double fl2 = 1e+37;
    const double fabmin = 1e-3;
    const double dthrd = 1e-7;
    complex h;
    complex dh, df;
    double fabss;
    h = htodh(*f, yr, yi);
    d_printf("f", *f);
    d_printf("h", h);
    ic++;
    if(ic > icmax || fabs(creal(h)) + fabs(cimag(h)) > fl2)
    {
      //printf("oops ");
      return 1;
    }
    dh = (h - h2)/(*f - f2);
    df = h/dh;
    h2 = h;
    f2 = *f;
    *f -= df;
    if(cabs(*f) > fabmin) fabss = cabs(*f);
    else fabss = fabmin;
    if(cabs(df)/fabss <= dthrd && ic != 1)
    {
      break;
    }
    if(creal(*f) < cxi || creal(*f) > cxa ||
       cimag(*f) < cyi || cimag(*f) > cya ||
       (cimag(*f) < 0 && -cimag(*f) > 0.2*fabs(creal(*f)))
    )
    {
      return 1;
    }
  }
  //if(cabs(h2) > 1e4) return 1; //;
  //printf("%lf\n", cabs(h2));
  d_printf("wkinit ", h2);
  return 0;
}
