#include <complex.h>
#include <stdlib.h>
#define __USE_BSD
#include <math.h>
#include <stdio.h> // test

#include "gtdispc.h"

static int wkinit_vv(double yr, double yi)
{
  int size, num_conv, max_sub;
  const double dsame = 1e-2;

  num_conv = 0;

  bessmd(yr);
  size = wkregn();
  
  for(int i = 0;i < size; i++)
  {
    if(!wkinit(fregn+i, yr, yi))
    {
//      if(creal(*(fregn + i)) >= 0 //&& 
        //!(cimag(*(fregn + i)) < 0) && ( creal(*(fregn+i)) <= 0 || -cimag(*(fregn+i))/creal(*(fregn+i)) > 0.1 ) )// should be implemented here
//        )
      {
        *(fregn + num_conv) = *(fregn + i);
        num_conv++;
      }
    }
  }

  sort_complex(fregn, num_conv);

  max_sub = num_conv;
  num_conv = 0;
  for(int i = 1; i<max_sub; i++)
  {
    complex s;
    s = *(fregn + i) - *(fregn + num_conv);
    if(cabs(s) > dsame)
    {
      num_conv++;
      *(fregn + num_conv) = *(fregn + i);
    };
    
  }
  if(max_sub != 0) num_conv++;

  return num_conv;
}

complex *fans;
double *rans;

int wkinit_v(double theta)
{
  double rkw, drkw;
  int total = 0;
  rkw = xcs;
  drkw = (xcl - xcs)/(nk - 1);

  fans = NULL;
  rans = NULL;
  create_kappa_table();///////////////////////////

  for(int i = 0;i < nk; i++)
  {
    double thr, yr, yi;
    int numm;
    complex *fans_t;
    double *rans_t;
    thr = theta/180*M_PI;
    yr = rkw*sin(thr);
    yi = rkw*cos(thr);
    numm = wkinit_vv(yr, yi);
    if(numm > 0)
    {
      fans_t = (complex *) realloc(fans, sizeof(complex) * (total + numm));
      //if(fans != fans_t) free(fans);
      fans = fans_t;
      for(int j = 0; j < numm; j++) *(fans + total + j) = *(fregn + j);
      rans_t = (double *) realloc(rans, sizeof(double) * (total + numm));
      //if(rans != rans_t) free(rans);
      rans = rans_t;
      for(int j = 0; j < numm; j++) *(rans + total + j) = rkw;
      total += numm;
    }
    rkw += drkw;
  }
  return total;
}
