#include <complex.h>
#include <stdbool.h>
#include <stdio.h>
#define __USE_BSD
#include <math.h>

#include "gtdispc.h"

complex z(complex *gg)
{
  double Reg, Img;
  int kind;
  double h, h2, s;
  int nu, capn; //????
  bool b;
  double r1, r2, s1, s2, lambda;
  double re,im;
  complex ctemp;
  complex g;
  g = *gg;
  Reg = creal(g);
  Img = cimag(g);
  kind = 1;
  if(Reg < 0)
  {
    kind++;
    Reg = - Reg;
  }
  if(Img < 0)
  {
    if(Img*Img - Reg*Reg > 3)
    {
      Img = -sqrt(Reg*Reg + 3);
      g = Reg + Img*I;
      *gg = g; //ok?
    }
    kind += 2;
    Img = -Img;
  }
  if(Img >= 4.29 || Reg >= 5.33)
  {
    h = 0;
    h2 = 0;
    capn = 0;
    nu = 8;
  }else{
    s = (1 - Img/4.29)*sqrt(1 - Reg*Reg/28.4089);
    h = 1.6*s;
    h2 = 2*h;
    capn = 6 + 23*s;
    nu = 9 + 21*s;
  }
  lambda = 0;
  if(h > 0) lambda = pow(h2, capn);
  b = (h==0 || lambda == 0);
  r1 = 0; r2 = 0; s1 = 0; s2 =0;
  for(int i = 0; i <= nu; i++)
  {
    int n, p1;
    double t1, t2, c;
    n = nu - i;
    p1 = n+1;
    t1 = Img + h + p1*r1;
    t2 = Reg - p1*r2;
    c = 0.5/(t1*t1 + t2*t2);
    r1 = c*t1;
    r2 = c*t2;
    if(h != 0 && n <= capn)
    {
      t1 = lambda + s1;
      s1 = r1*t1 - r2*s2;
      s2 = r2*t1 + r1*s2;
      lambda /= h2;
    }
  }
  if(Img != 0)
  {
    if(b) re = 2*r1;
    else re = 2*s1;
  }else re = sqrt(M_PI)*exp(-Reg*Reg);
  if(b) im = 2*r2;
  else im = 2*s2;
  switch (kind){
    case 1: ctemp = -im + re*I;return ctemp;
    case 2: ctemp = im + re*I;return ctemp;
    case 3: ctemp = -im - re*I;break;
    case 4: ctemp = im - re*I;break;
    default: printf("error\n");
  }
  ctemp += 3.54490770181*I*cexp(-g*g);
  return ctemp;
}

























