function h = polor_axis(r_max, r_div, t_div)

hold on;
axis square;
axis off;

% draw the boundary
h = plot([0 r_max],[0 0],'k');
plot([0 0], [0 r_max],'k');
x = r_max*cos(0:pi/500:pi/2);
y = r_max*sin(0:pi/500:pi/2);
plot(x,y,'k');

% draw radial sub-axes and put text
for m = 1:r_div-1
    theta = m*90/r_div;
    x = r_max*cos(theta*pi/180);
    y = r_max*sin(theta*pi/180);
    plot([0 x],[0 y],'k--')
    str = sprintf('%d^o',theta);
    text(x*1.02,y*1.02,str);
end
text(r_max*1.02,0,'0^o');
text(0, r_max*1.02,'90^o');

% draw circular sub-axes and put text
ndigit = log10(r_max);
ndigit =  floor(ndigit);
for m = 1:t_div-1
    r = r_max/t_div*m;
    x = r*cos(0:pi/500:pi/2);
    y = r*sin(0:pi/500:pi/2);
    plot(x,y,'k--');
    str = sprintf('%1.2f',r/10^ndigit);
    text(r, 0, str,'HorizontalAlignment', 'center', 'VerticalAlignment', 'top');
end
str = sprintf('%1.2f\nx10^{%d}', r_max/10^ndigit, ndigit);
text(r_max, 0 , str, 'HorizontalAlignment', 'center', 'VerticalAlignment', 'top');