#include <complex.h>
#define __USE_BSD
#include <math.h>
#include <float.h>
#include "header.h"

double  b_k(c_vec E, double theta , complex w){
  c_vec K, B;
  double angle;

  if(cabs(w) == 0){
    return -DBL_MAX;
  }else{
    angle = theta/180*M_PI;
    K.x = sin(angle);
    K.y = 0;
    K.z = cos(angle);
    B = cross_product(E,K);
    B.x /= w;
    B.y /= w;
    B.z /= w;
    B = normalize_c_vec(B);
    return cabs(dot_product(B,K));
  }
}
