#include <math.h>
#include <complex.h>
#include "header.h"

/*
 * calculate the dot product of A and B
 */
complex dot_product(c_vec A, c_vec B){
  return A.x*conj(B.x) + A.y*conj(B.y) + A.z*conj(B.z);
}

/*
 * normalize the vector
 */
c_vec normalize_c_vec(c_vec A){
  double t;
  c_vec B;
  t = cabs(dot_product(A, A));
  B.x = A.x/t;
  B.y = A.y/t;
  B.z = A.z/t;
  return B;
}

double norm_c_vec(c_vec A){
  return cabs(dot_product(A, A));
}
