#include <complex.h>
#define __USE_BSD
#include <math.h>
#include <float.h>
#include "header.h"

double e_by_b(c_vec E, double theta , complex w, double k){
  c_vec K, B;
  double angle;

  if(cabs(w) == 0){
    return 0;
  }else{
    double nE, nB;
    angle = theta/180*M_PI;
    K.x = k*sin(angle);
    K.y = 0;
    K.z = k*cos(angle);
    B = cross_product(E,K);
    B.x /= w;
    B.y /= w;
    B.z /= w;
    
    nE = norm_c_vec(E);
    nB = norm_c_vec(B);
    if(nB == 0.) return DBL_MAX;
    else return nE/nB;
  }
}
