#include <complex.h>
#define __USE_BSD
#include <math.h>
#include <float.h>
#include "header.h"

double e_para_to_perp_k(c_vec E, double theta){
  complex Epara;
  c_vec Eperp;
  double nEperp, nEpara;
  double angle;
  c_vec K;

  angle = theta*M_PI/180;
  K.x = sin(angle);
  K.y = 0;
  K.z = cos(angle);

  Epara = dot_product(E,K);
  Eperp.x = E.x - Epara*K.x;
  Eperp.y = E.y;
  Eperp.z =     - Epara*K.z;

  nEperp = norm_c_vec(Eperp);
  nEpara = cabs(Epara);

  if(nEperp == 0.) return DBL_MAX;
  else return nEpara/nEperp;

}
