#include <math.h>
#include <complex.h>
#include "header.h"

double ellipticity(c_vec E, complex w){
  double a, b, c;
  double alpha, beta, gamma;
  double A, B, C;
  double elp;
  double D,F;
  int sign;

  a = cabs(E.x);
  b = cabs(E.y);
  c = cabs(E.z);
  alpha = carg(E.x);
  beta = carg(E.y);
  gamma = carg(E.z);

  A = pow(a*cos(alpha),2) + pow(b*cos(beta), 2) + pow(c*cos(gamma), 2);
  B = -(a*a*sin(2*alpha) + b*b*sin(2*beta) + c*c*sin(2*gamma))/2;
  C = pow(a*sin(alpha),2) + pow(b*sin(beta), 2) + pow(c*sin(gamma), 2);

  D = sqrt(pow((A-C)/2,2) + B*B);
  F = (A+C)/2;
  elp = sqrt((F-D)/(F+D));

  sign = cimag(E.x/E.y) > 0 ? 1 : -1;
  sign = creal(w) > 0 ? sign : -sign;

  return elp*sign;
}
