#include <stdio.h>
#define __USE_BSD
#include <math.h>
#include <string.h>
#include <complex.h>
#include "headerO.h"
#include "../LIB/header.h"
#include <stdlib.h>
#include <float.h>

/*
 * e_dot_k
 * input: filename
 * output:
 * The output is a map of (E,k)
 */

void usage(void){
  printf("e_dot_k filename\n");
}

int main(int argc, char *argv[]){
  complex **h1, **h2, **h3, **h4, **h5, **h6;
  double **k, **r, **w, pro_angle;
  int iteration;

  if(argc != 4){
    usage();
    exit(EXIT_FAILURE);
  }

  iteration = load_kwr(argv[1], &k, &w, &r);
  load_h(argv[2], &h1, &h2, &h3, &h4, &h5, &h6);
  pro_angle = strtod(argv[3],NULL);
  double thr;
  thr = pro_angle*M_PI/180;

  for(int i = 0; i < iteration; i++){
    for(int j = 0; j < 200; j++){
      c_vec E, K;
      if(creal(*(*(h1+i)+j)) == -DBL_MAX) break;
      E = e_ratio(pro_angle, *(*(h1+i)+j), *(*(h2+i)+j), *(*(h3+i)+j), *(*(h4+i)+j), *(*(h5+i)+j), *(*(h6+i)+j));
      E = normalize_c_vec(E);
      K.x = cos(thr);
      K.y = 0;
      K.z = sin(thr);
      printf("%e\n", cabs(dot_product(E, K)));
    }
    printf("\n");
  }
}
