#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <complex.h>

#define MAX_LINES 100
#define MAX_DATA 200

/* inputs
 * filename - file name
 * h1
 * h2
 * h3
 * h4
 * h5
 * h6
 */
/* return
 * the number of lines
 * -1 will be returned if an error is happened such as the file does not exist
 * 101 will be retured the number of lines is too many
 */
int load_h(char *filename, complex ***h1, complex ***h2, complex ***h3, complex ***h4, complex ***h5, complex ***h6){
  FILE *fp;
  int nlines = 0;

  *h1 = (complex **) malloc(sizeof(complex *)*MAX_LINES);
  *h2 = (complex **) malloc(sizeof(complex *)*MAX_LINES);
  *h3 = (complex **) malloc(sizeof(complex *)*MAX_LINES);
  *h4 = (complex **) malloc(sizeof(complex *)*MAX_LINES);
  *h5 = (complex **) malloc(sizeof(complex *)*MAX_LINES);
  *h6 = (complex **) malloc(sizeof(complex *)*MAX_LINES);

  fp = fopen(filename, "r");
  if(fp == NULL) return -1;
  else{
    char text[1000];
    int i = 0;
    **h1 = (complex *) malloc(sizeof(complex)*MAX_DATA);
    **h2 = (complex *) malloc(sizeof(complex)*MAX_DATA);
    **h3 = (complex *) malloc(sizeof(complex)*MAX_DATA);
    **h4 = (complex *) malloc(sizeof(complex)*MAX_DATA);
    **h5 = (complex *) malloc(sizeof(complex)*MAX_DATA);
    **h6 = (complex *) malloc(sizeof(complex)*MAX_DATA);
    while(fgets(text, 1000, fp)){
      if(*text == '\n'){
        if(i != MAX_DATA){
          *(*(*h1 + nlines) + i) = -DBL_MAX;
          *(*(*h2 + nlines) + i) = -DBL_MAX;
          *(*(*h3 + nlines) + i) = -DBL_MAX;
          *(*(*h4 + nlines) + i) = -DBL_MAX;
          *(*(*h5 + nlines) + i) = -DBL_MAX;
          *(*(*h6 + nlines) + i) = -DBL_MAX;
        }
        i = 0;
        nlines++;
        if(nlines < MAX_LINES){
          *(*h1+nlines) = (complex *) malloc(sizeof(complex)*MAX_DATA);
          *(*h2+nlines) = (complex *) malloc(sizeof(complex)*MAX_DATA);
          *(*h3+nlines) = (complex *) malloc(sizeof(complex)*MAX_DATA);
          *(*h4+nlines) = (complex *) malloc(sizeof(complex)*MAX_DATA);
          *(*h5+nlines) = (complex *) malloc(sizeof(complex)*MAX_DATA);
          *(*h6+nlines) = (complex *) malloc(sizeof(complex)*MAX_DATA);
        }
      }else{
        char *endptr1, *endptr2;
        *(*(*h1 + nlines) + i) = strtod(text, &endptr1);
        *(*(*h1 + nlines) + i) += strtod(endptr1, &endptr2)*I;
        *(*(*h2 + nlines) + i) = strtod(endptr2, &endptr1);
        *(*(*h2 + nlines) + i) += strtod(endptr1, &endptr2)*I;
        *(*(*h3 + nlines) + i) = strtod(endptr2, &endptr1);
        *(*(*h3 + nlines) + i) += strtod(endptr1, &endptr2)*I;
        *(*(*h4 + nlines) + i) = strtod(endptr2, &endptr1);
        *(*(*h4 + nlines) + i) += strtod(endptr1, &endptr2)*I;
        *(*(*h5 + nlines) + i) = strtod(endptr2, &endptr1);
        *(*(*h5 + nlines) + i) += strtod(endptr1, &endptr2)*I;
        *(*(*h6 + nlines) + i) = strtod(endptr2, &endptr1);
        *(*(*h6 + nlines) + i) += strtod(endptr1, &endptr2)*I;
        i++;
      }
    }
  }

  return nlines;
}

void free_h(int nlines, complex **h1, complex **h2, complex **h3, complex **h4, complex **h5, complex **h6){
  for(int i = 0; i < nlines; i++){
    free(*(h1 + i));
    free(*(h2 + i));
    free(*(h3 + i));
    free(*(h4 + i));
    free(*(h5 + i));
    free(*(h6 + i));
  }
  free(h1);
  free(h2);
  free(h3);
  free(h4);
  free(h5);
  free(h6);
}
