#include <stdio.h>
#define __USE_BSD
#include <math.h>
#include <string.h>
#include <complex.h>
#include "headerT.h"
#include "../LIB/header.h"
#include <stdlib.h>

/*
 * e_dot_k
 * input: filename
 * output:
 * The output is a map of (E,k)
 */

void usage(void){
  printf("e_dot_k filename\n");
}

int main(int argc, char *argv[]){
  char* dot_txt_start;
  char prefix[1024];
  int prefix_len;

  complex *w, *h1, *h2, *h3, *h4, *h5, *h6;
  double *k, pro_angle;

  if(argc != 2){
    usage();
    exit(EXIT_FAILURE);
  }

  open_files_h(argv[1]);

  for(int i = 0; i <= 90; i++){
    double thr;
    pro_angle = read_h(&k, &w, &h1, &h2, &h3, &h4, &h5, &h6);
    thr = pro_angle/180*M_PI;
    for(int j = 0; j < 600; j++){
      c_vec E, K;
      E = e_ratio(pro_angle, *(h1+j), *(h2+j), *(h3+j), *(h4+j), *(h5+j), *(h6+j));
      E = normalize_c_vec(E);
      K.x = cos(thr);
      K.y = 0;
      K.z = sin(thr);
      printf("%e\t", cabs(dot_product(E, K)));
    }
    printf("\n");
  }

  close_files_h();

}
