#include <stdio.h>
#define __USE_BSD
#include <math.h>
#include <string.h>
#include <complex.h>
#include "headerT.h"
#include "../LIB/header.h"
#include <stdlib.h>

/*
 * resonance filename cfreq order
 * input: filename
 * input: cfreq cyclotron
 * input: order of resonance
 * output:
 * The output is a map of (E,k)
 */

void usage(void){
  printf("resonance filename cfreq order\n");
}

int main(int argc, char *argv[]){
  double cfreq;
  int order;
  complex *w, *h1, *h2, *h3, *h4, *h5, *h6;
  double *k;

  if(argc != 4){
    usage();
    exit(EXIT_FAILURE);
  }

  cfreq = strtod(argv[2],NULL);
  order = atoi(argv[3]);
  open_files_h(argv[1]);

  for(int i = 0; i <= 90; i++){
    double thr;
    thr = read_h(&k, &w, &h1, &h2, &h3, &h4, &h5, &h6)/180*M_PI;
    for(int j = 0; j < 600; j++){
      double freq,v;
      freq = creal(*(w+j));
      v = (freq - order*cfreq)/ *(k+j)*cos(thr);
      printf("%e\t",v);
    }
    printf("\n");
  }

  close_files_h();

}
