#include <gtk/gtk.h>
#include <stdlib.h>
#include <complex.h>
#include "graph.h"
#include "../gtdispc.h"

#define NPARAM 9

double wc;
double cv;
int num;

double *an;
double *wpd;
double *qm;
double *peth;
double *path;
double *spa;
double *loss0;
double *bfac;
double *ppp;

double *ran;
double *rm;
double *rn;
double *wp;
double *t;
double *tr;
double *v;
double *closs1;
double *closs2;

double yne;
double ylri;
double c;
double b;
double val;

double theta;

double xcs;
double xcl;
double xst;
double cxi;
double cxa;
double cyi;
double cya;

int nx, ny, nk;

complex ff[200];
double rrkk[200];
complex *fans;
double *rans;
complex *fff[10000];
double *rrr[10000];

int ans;

static GdkColor colorBlue;
GtkWidget *Window, *Parameters, *Vbox, *CanvasWK, *CanvasGK, *CanvasGW, *CanvasVG, *Parameters2, *Axes;

typedef struct{
  double q;
  double qm;
  double wp;
  double vperp;
  double vpara;
  double drift;
  double loss0;
  double bfac;
  double ppp;
} parameter;

parameter *param;

GtkWidget **param_map;

GtkWidget *Ewc, *Ecv, *Etheta, *Excs, *Excl, *Ecxi, *Ecxa, *Ecyi, *Ecya;

GtkWidget *Akmin, *Akmax, *Afmin, *Afmax, *Agmin, *Agmax, *Avgmin, *Avgmax;

void restore_parameters(void){
  char text[21];
  for(int i=0;i<num;i++){
    double q,qm,wp,vperp,vpara,drift,loss0, bfac,ppp;
    q = (param+i)->q;
    qm = (param+i)->qm;
    wp = (param+i)->wp;
    vperp = (param+i)->vperp;
    vpara = (param+i)->vpara;
    drift = (param+i)->drift;
    loss0 = (param+i)->loss0;
    bfac = (param+i)->bfac;
    ppp = (param+i)->ppp;
    snprintf(text,20,"%e", q);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+0)),text);
    snprintf(text,20,"%e", qm);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+1)),text);
    snprintf(text,20,"%e", wp);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+2)),text);
    snprintf(text,20,"%e", vperp);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+3)),text);
    snprintf(text,20,"%e", vpara);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+4)),text);
    snprintf(text,20,"%e", drift);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+5)),text);
    snprintf(text,20,"%e", loss0);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+6)),text);
    snprintf(text,20,"%e", bfac);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+7)),text);
    snprintf(text,20,"%e", ppp);
    gtk_entry_set_text(GTK_ENTRY(*(param_map+i*NPARAM+8)),text);

  }

  snprintf(text,20,"%e", wc);
  gtk_entry_set_text(GTK_ENTRY(Ewc),text);
  snprintf(text,20,"%e", cv);
  gtk_entry_set_text(GTK_ENTRY(Ecv),text);
  snprintf(text,20,"%e", theta);
  gtk_entry_set_text(GTK_ENTRY(Etheta),text);
  snprintf(text,20,"%e", xcs);
  gtk_entry_set_text(GTK_ENTRY(Excs),text);
  gtk_entry_set_text(GTK_ENTRY(Akmin),text);
  snprintf(text,20,"%e", xcl);
  gtk_entry_set_text(GTK_ENTRY(Excl),text);
  gtk_entry_set_text(GTK_ENTRY(Akmax),text);
  snprintf(text,20,"%e", cxi);
  gtk_entry_set_text(GTK_ENTRY(Ecxi),text);
  gtk_entry_set_text(GTK_ENTRY(Afmin),text);
  snprintf(text,20,"%e", cxa);
  gtk_entry_set_text(GTK_ENTRY(Ecxa),text);
  gtk_entry_set_text(GTK_ENTRY(Afmax),text);
  snprintf(text,20,"%e", cyi);
  gtk_entry_set_text(GTK_ENTRY(Ecyi),text);
  gtk_entry_set_text(GTK_ENTRY(Agmin),text);
  snprintf(text,20,"%e", cya);
  gtk_entry_set_text(GTK_ENTRY(Ecya),text);
  gtk_entry_set_text(GTK_ENTRY(Agmax),text);
  snprintf(text,20,"%d", 0);
  gtk_entry_set_text(GTK_ENTRY(Avgmin),text);
  snprintf(text,20,"%e", cv);
  gtk_entry_set_text(GTK_ENTRY(Avgmax),text);
}

/*
  1 fail to read
  2 fail to parse
*/
static GtkWidget *parameters_new(guint num_particle);
static gint parse_data(gchar* filename){
  FILE *fp=NULL;
  parameter *tparam = NULL;
  fp = fopen(filename, "r");
  if(fp){
    int result;
    result = fscanf(fp, "%d %lf %lf\n", &num, &wc, &cv);
    if(result != 3 || num <= 0 || wc == 0 || cv <= 0) goto file_is_dead;
    result = fscanf(fp, "%d %d %d\n", &nx, &ny, &nk);
    if(result != 3 || nx <= 0 || ny <= 0 || nk <= 0) goto file_is_dead;
    result = fscanf(fp, "%lf\n", &theta);
    if(result != 1 || theta > 90 || theta < 0) goto file_is_dead;
    result = fscanf(fp, "%lf %lf\n", &xcs, &xcl);
    if(result != 2 || xcs < 0 || xcl < xcs) goto file_is_dead;
    result = fscanf(fp, "%lf %lf\n", &cxi, &cxa);
    if(result != 2 ||  cxa < cxi) goto file_is_dead;
    result = fscanf(fp, "%lf %lf\n", &cyi, &cya);
    if(result != 2 ||  cya < cyi) goto file_is_dead;
    tparam = (parameter *) malloc(sizeof(parameter)*num);
    //if(!an || !wpd || !qm || !peth || !path || !spa || !loss0 || !bfac || !ppp) goto malloc_error;
    for(int i = 0; i < num; i++){
      result = fscanf(fp, "%lf %lf %lf\n", &((tparam+i)->q), &((tparam+i)->wp), &((tparam+i)->qm));
      if(result != 3) goto file_is_dead;
      result = fscanf(fp, "%lf %lf %lf\n", &((tparam+i)->vperp), &((tparam+i)->vpara), &((tparam+i)->drift));
      if(result != 3) goto file_is_dead;
      result = fscanf(fp, "%lf %lf %lf\n", &((tparam+i)->loss0), &((tparam+i)->bfac), &((tparam+i)->ppp));
      if(result != 3) goto file_is_dead;
    }
    free(param);
    param = tparam;
    gtk_widget_destroy(Parameters);
    Parameters = parameters_new(num);
    gtk_box_pack_start(GTK_BOX(Vbox), Parameters, FALSE, FALSE, 1);
    gtk_box_reorder_child(GTK_BOX(Vbox), Parameters, 1);
    restore_parameters();
    gtk_widget_show_all(Parameters);
  }else{
    return 1;
  }
  return 0;
  file_is_dead:
    if(!tparam) free(tparam);
    return 2;
}


static void set_color(void){
  gdk_color_parse("blue", &colorBlue);
}

static void destroy(GtkWidget *w, gpointer p){
  g_message("Program closed");
  gtk_main_quit();
}

static void get_paramters(GtkWidget *w, gpointer p){
  if(an != NULL) free(an);

  clear_line(CanvasWK);
  clear_line(CanvasGK);
  clear_line(CanvasGW);
  clear_line(CanvasVG);

  an    = (double *) malloc(sizeof(double) * num * 9);
  qm    = an + num*1;
  wpd   = an + num*2;
  peth  = an + num*3;
  path  = an + num*4;
  spa   = an + num*5;
  loss0 = an + num*6;
  bfac  = an + num*7;
  ppp   = an + num*8;
  for(int i =0; i<num;i++){
    for(int j = 0; j < NPARAM; j++){
      GtkWidget *entry;
      entry = *(param_map + i*NPARAM + j);
      *(an + j*num + i) = strtod(gtk_entry_get_text(GTK_ENTRY(entry)), NULL);
    }
  }
  wc = strtod(gtk_entry_get_text(GTK_ENTRY(Ewc)), NULL);
  cv = strtod(gtk_entry_get_text(GTK_ENTRY(Ecv)), NULL);
  theta = strtod(gtk_entry_get_text(GTK_ENTRY(Etheta)), NULL);
  xcs = strtod(gtk_entry_get_text(GTK_ENTRY(Excs)), NULL);
  xcl = strtod(gtk_entry_get_text(GTK_ENTRY(Excl)), NULL);
  cxi = strtod(gtk_entry_get_text(GTK_ENTRY(Ecxi)), NULL);
  cxa = strtod(gtk_entry_get_text(GTK_ENTRY(Ecxa)), NULL);
  cyi = strtod(gtk_entry_get_text(GTK_ENTRY(Ecyi)), NULL);
  cya = strtod(gtk_entry_get_text(GTK_ENTRY(Ecya)), NULL);
  calculate_unit();
  get_basic_parameters();
  ans = wkinit_v(theta);
  ans = wkcurv_v(ans, theta);
  set_xrange(CanvasWK, xcs, xcl);
  set_yrange(CanvasWK, cxi, cxa);
  set_xrange(CanvasGK, xcs, xcl);
  set_yrange(CanvasGK, cyi, cya);
  set_xrange(CanvasGW, cxi, cxa);
  set_yrange(CanvasGW, cyi, cya);
  set_xrange(CanvasVG, xcs, xcl);
  set_yrange(CanvasVG, 0, cv);
  double *f, *g, *vg;
  int length;
  f = (double *)malloc(sizeof(double) * 200 * ans);
  g = (double *)malloc(sizeof(double) * 200 * ans);
  vg = (double *)malloc(sizeof(double) * 200 * ans);
  int r = 0, gr = 0, b = 0;
  int d0, d1, d2, d3, d4, d5, d6, d7, d8;
  d0 = 1;
  d1 = d0 << 1; 
  d2 = d0 << 2; 
  d3 = d0 << 3; 
  d4 = d0 << 4; 
  d5 = d0 << 5; 
  d6 = d0 << 6; 
  d7 = d0 << 7; 
  for(int i = 0; i < ans; i++){
    length = 200;
    double rr, gg, bb;
    rr = 0;
    gg = 0;
    bb = 0;
    for(int j = 0; j < 200; j++)
      if(*(rrr[i] + j) != -DBL_MAX){
        *(f+i*200+j) = creal(*(fff[i] + j));
        *(g+i*200+j) = cimag(*(fff[i] + j));
      }
      else {
        length = j;
        break;
      }
    rr += ((d0 & r) > 0) ? d7 :0;
    rr += ((d1 & r) > 0) ? d6 :0;
    rr += ((d2 & r) > 0) ? d5 :0;
    rr += ((d3 & r) > 0) ? d4 :0;
    rr += ((d4 & r) > 0) ? d3 :0;
    rr += ((d5 & r) > 0) ? d2 :0;
    rr += ((d6 & r) > 0) ? d1 :0;
    rr += ((d7 & r) > 0) ? d0 :0;
    rr /= 256;
    gg += ((d0 & gr) > 0) ? d7 :0;
    gg += ((d1 & gr) > 0) ? d6 :0;
    gg += ((d2 & gr) > 0) ? d5 :0;
    gg += ((d3 & gr) > 0) ? d4 :0;
    gg += ((d4 & gr) > 0) ? d3 :0;
    gg += ((d5 & gr) > 0) ? d2 :0;
    gg += ((d6 & gr) > 0) ? d1 :0;
    gg += ((d7 & gr) > 0) ? d0 :0;
    gg /= 256;
    bb += ((d0 & b) > 0) ? d7 :0;
    bb += ((d1 & b) > 0) ? d6 :0;
    bb += ((d2 & b) > 0) ? d5 :0;
    bb += ((d3 & b) > 0) ? d4 :0;
    bb += ((d4 & b) > 0) ? d3 :0;
    bb += ((d5 & b) > 0) ? d2 :0;
    bb += ((d6 & b) > 0) ? d1 :0;
    bb += ((d7 & b) > 0) ? d0 :0;
    bb /= 256;
    // sort
    for(int j = 0; j < length-1; j++){
      int mm;
      double temp;
      mm = j;
      for(int jj = j+1; jj < length; jj++){
        mm = *(rrr[i] + mm) > *(rrr[i] + jj) ? jj : mm;
      }
      temp = *(rrr[i] + j);
      *(rrr[i] + j) = *(rrr[i] + mm);
      *(rrr[i] + mm) = temp;
      temp = *(f + i*200 + j);
      *(f + i*200 + j) = *(f + i*200 + mm);
      *(f + i*200 + mm) = temp;
      temp = *(g + i*200 + j);
      *(g + i*200 + j) = *(g + i*200 + mm);
      *(g + i*200 + mm) = temp;
    }
    append_line(CanvasWK, rrr[i], (f + i*200), length, rr, gg, bb);
    append_line(CanvasGK, rrr[i], (g + i*200), length, rr, gg, bb);
    append_line(CanvasGW, (f+i*200), (g + i*200), length, rr, gg, bb);

    // calculate group velocity
    for(int j = 0; j < length - 1;j++){
      *(vg + i*200 + j) = (*(f + i*200 + j + 1) - *(f + i*200 + j))/(*(rrr[i] + j + 1) - *(rrr[i] + j));
    }
    if(length != 1){
      *(vg + i*200 + length-1) = *(vg + i*200 + length - 2);
      append_line(CanvasVG, rrr[i], (vg + i*200), length, rr, gg, bb);
    }

    switch (i%3){
      case 0:
        r++; break;
      case 1:
        gr++; break;
      case 2:
        b++; break;
    }
  }
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);
  gtk_widget_queue_draw(CanvasVG);
}

static GtkWidget *parameters_new(guint num_particle){
  GtkWidget *hbox;
  if(num_particle == 0) return NULL;
  if(param_map != NULL) free(param_map);
  param_map = (GtkWidget **) malloc(num_particle*NPARAM*sizeof(GtkWidget *));
  num = (int) num_particle;
  hbox = gtk_hbox_new(FALSE, 3);
  for(int i = -1;i<(int)num_particle;i++){
    GtkWidget *vbox;
    vbox = gtk_vbox_new(FALSE, 1);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE,  TRUE, 3);
    if(i < 0){
      GtkWidget *label;
      label = gtk_label_new("q");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("q/m"); gtk_widget_modify_base(label, GTK_STATE_NORMAL, &colorBlue);
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("wp or n/n1");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("v//"); gtk_widget_modify_base(label, GTK_STATE_NORMAL, &colorBlue);
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("v|");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("drift");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("loss0");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("bfac");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
      label = gtk_label_new("ppp");
      gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 1);
    }else{
      for(int j = 0;j<NPARAM;j++){
        GtkWidget *entry;
        entry = gtk_entry_new();
        *(param_map + i*NPARAM + j) = entry;
        if(j%2 == 1)gtk_widget_modify_base(entry, GTK_STATE_NORMAL, &colorBlue);
        gtk_box_pack_start(GTK_BOX(vbox), entry, FALSE, FALSE, 1);
      }
    }
  }
  GtkWidget *button;
  button = gtk_button_new_with_label("calculate");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(get_paramters), NULL);
  gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 1);

  return hbox;
}

static void change_axes(GtkWidget *w, gpointer p){
  char *text;
  double kmin, kmax, fmin, fmax, gmin, gmax, vgmin, vgmax;
  kmin = strtod(gtk_entry_get_text(GTK_ENTRY(Akmin)), NULL);
  kmax = strtod(gtk_entry_get_text(GTK_ENTRY(Akmax)), NULL);
  fmin = strtod(gtk_entry_get_text(GTK_ENTRY(Afmin)), NULL);
  fmax = strtod(gtk_entry_get_text(GTK_ENTRY(Afmax)), NULL);
  gmin = strtod(gtk_entry_get_text(GTK_ENTRY(Agmin)), NULL);
  gmax = strtod(gtk_entry_get_text(GTK_ENTRY(Agmax)), NULL);
  vgmin = strtod(gtk_entry_get_text(GTK_ENTRY(Avgmin)), NULL);
  vgmax = strtod(gtk_entry_get_text(GTK_ENTRY(Avgmax)), NULL);
  set_xrange(CanvasWK, kmin, kmax);
  set_yrange(CanvasWK, fmin, fmax);
  set_xrange(CanvasGK, kmin, kmax);
  set_yrange(CanvasGK, gmin, gmax);
  set_xrange(CanvasGW, fmin, fmax);
  set_yrange(CanvasGW, gmin, gmax);
  set_xrange(CanvasVG, kmin, kmax);
  set_yrange(CanvasVG, vgmin, vgmax);
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);
  gtk_widget_queue_draw(CanvasVG);

}

GtkWidget *axes_new(void){
  GtkWidget *table, *button;
  table = gtk_table_new(5,5, TRUE);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("k"), 0, 1,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("f"), 0, 1,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("gamma"), 0, 1,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("vg"), 0, 1,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Akmin = gtk_entry_new();
  Afmin = gtk_entry_new();
  Agmin = gtk_entry_new();
  Avgmin = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(table), Akmin, 1, 2,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), Afmin, 1, 2,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), Agmin, 1, 2,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), Avgmin, 1, 2,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("-"), 2, 3,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("-"), 2, 3,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("-"), 2, 3,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("-"), 2, 3,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Akmax = gtk_entry_new();
  Afmax = gtk_entry_new();
  Agmax = gtk_entry_new();
  Avgmax = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(table), Akmax, 3, 4,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), Afmax, 3, 4,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), Agmax, 3, 4,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), Avgmax, 3, 4,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  button = gtk_button_new_with_label("calculate");
  gtk_table_attach(GTK_TABLE(table), button, 4, 5,0 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(change_axes), NULL);
  return table;
}

static const gchar *menu_info =
  "<ui>"
  "  <menubar name='Menubar'>"
  "    <menu name='File' action='File'>"
  "      <menuitem name='Open' action='Open'/>"
  "      <separator/>"
  "      <menuitem name='Quit' action='Quit'/>"
  "    </menu>"
  "    <menu name='Edit' action='Edit'>"
  "      <menuitem name='Num' action='Num'/>"
  "    </menu>"
  "    <menu name='View' action='View'>"
  "      <menuitem name='param1' action='param1'/>"
  "      <menuitem name='param2' action='param2'/>"
  "      <menuitem name='axes' action='axes'/>"
  "      <menuitem name='w-k' action='w-k'/>"
  "      <menuitem name='g-k' action='g-k'/>"
  "      <menuitem name='g-w' action='g-w'/>"
  "      <menuitem name='vg-k' action='vg-k'/>"
  "      <separator/>"
  "      <menuitem name='Log' action='Log'/>"
  "    </menu>"
  "    <menu name='Calculate' action='Calculate'>"
  "      <menuitem name='Test' action='Test'/>"
  "    </menu>"
  "  </menubar>"
  "</ui>";

static void cb_quit(GtkAction *action, gpointer user_data){
  gtk_main_quit();
}

static void cb_open(GtkAction *action, gpointer user_data){
  GtkWidget *dialog;
  gint response;
  dialog = gtk_file_chooser_dialog_new("Restore parameters", GTK_WINDOW(Window), GTK_FILE_CHOOSER_ACTION_OPEN,\
    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
  gtk_widget_show_all(dialog);
  response = gtk_dialog_run(GTK_DIALOG(dialog));
  if ( response == GTK_RESPONSE_ACCEPT){
    int result;
    gchar *filename;
    filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
    result = parse_data(filename);
    g_free(filename);
    if(result == 1) g_message("fail to load");
    else if(result == 2) g_message("fail to parse");
  }
  gtk_widget_destroy(dialog);
}

static void cb_change_num(GtkAction *action, gpointer user_data){
  GtkWidget *dialog, *content, *entry;
  gint response;
  dialog = gtk_dialog_new_with_buttons("Change the number of particles", GTK_WINDOW(Window), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK,\
    GTK_RESPONSE_OK);
  //content = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  content = ((GtkDialog*) dialog)->vbox;
  entry = gtk_entry_new();
  gtk_widget_show(entry);
  gtk_box_pack_start(GTK_BOX(content), entry, FALSE, FALSE ,1);
  while(1){
    response = gtk_dialog_run(GTK_DIALOG(dialog));
    if(response == GTK_RESPONSE_OK){
      gchar* text = gtk_entry_get_text(GTK_ENTRY(entry));
      int t;
      t = (int) strtol(text, NULL,10);
      if(t <= 0 || t > 10) {
        continue;
      }
      num = t;
      gtk_widget_destroy(Parameters);
      Parameters = parameters_new(num);
      free(param);
      param = (parameter *) malloc(sizeof(parameter)*num);
      gtk_box_pack_start(GTK_BOX(Vbox), Parameters, FALSE, FALSE, 1);
      gtk_box_reorder_child(GTK_BOX(Vbox), Parameters, 1);
      gtk_widget_show_all(Parameters);
      break;
    }else {
      break;
    }
  }
  gtk_widget_destroy(dialog);
}

static void cb_log(GtkAction *action, gpointer user_data);

static int line_number;

static gboolean test1(gpointer user_data){
  static gboolean ok = TRUE;
  if(ok){
    show_line(CanvasWK, line_number);
  }else{
    hide_line(CanvasWK, line_number);
  }
  ok = !ok;
  gtk_widget_queue_draw(CanvasWK);
  return TRUE;
}

static guint index;

static void cb_value_changed(GtkSpinButton *spinbutton, gpointer data){
  static gdouble val_before = 0;
  gdouble val;
  val = gtk_spin_button_get_value(spinbutton);
  line_number = (int) val;
  g_source_remove(index);
  index = g_timeout_add(400, test1, NULL);
  if(val != val_before){
    show_line(CanvasWK, (int) val_before);
  }
  val_before = val;
}

static void cb_test(GtkAction *action, gpointer user_data){
  GtkWidget *dialog, *content, *spinbutton;
  gint response;
  dialog = gtk_dialog_new_with_buttons("TEST", GTK_WINDOW(Window), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK,\
    GTK_RESPONSE_OK);
  //content = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  index = 0;
  content = ((GtkDialog*) dialog)->vbox;
  spinbutton = gtk_spin_button_new_with_range(0, ans, 1);
  gtk_spin_button_set_digits(GTK_SPIN_BUTTON(spinbutton), 0);
  gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinbutton), TRUE);
  gtk_signal_connect(G_OBJECT(spinbutton), "value-changed", G_CALLBACK(cb_value_changed), NULL);
  gtk_widget_show(spinbutton);
  gtk_box_pack_start(GTK_BOX(content), spinbutton, FALSE, FALSE ,1);
  
  while(1){
    response = gtk_dialog_run(GTK_DIALOG(dialog));
    if(response == GTK_RESPONSE_OK){
      break;
    }else {
      break;
    }
  }
  g_source_remove(index);
  for(int i = 0;i < ans; i++){
    show_line(CanvasWK, i);
  }
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_destroy(dialog);
}

static GtkActionEntry entries[] = {
  {"File", NULL, "_File"},
  {"Open", GTK_STOCK_OPEN, "_Open", "<control>O", "Restore data from file", G_CALLBACK(cb_open)},
  {"Quit", GTK_STOCK_QUIT, "_Quit", "<control>Q", "Quit this program", G_CALLBACK(cb_quit)},
  {"Edit", NULL, "_Edit"},
  {"Num", NULL, "_Num", "<control>N", "Change the number of kinds of particles", G_CALLBACK(cb_change_num)},
  {"View", NULL, "_View"},
  {"Log", NULL, "_Log", NULL, "Change scale", G_CALLBACK(cb_log)},
  {"Calculate", NULL, "_Calculate"},
  {"Test", NULL, "_Test", NULL, "do something", G_CALLBACK(cb_test)},
};

static void cb_wk(GtkAction *action, gpointer user_data){
  static gboolean ok = FALSE;
  ok  = !ok;
  if(ok) gtk_widget_hide(CanvasWK);
  else gtk_widget_show(CanvasWK);
}

static void cb_gk(GtkAction *action, gpointer user_data){
  static gboolean ok = TRUE;
  ok  = !ok;
  if(ok) gtk_widget_hide(CanvasGK);
  else gtk_widget_show(CanvasGK);
}

static void cb_gw(GtkAction *action, gpointer user_data){
  static gboolean ok = TRUE;
  ok  = !ok;
  if(ok) gtk_widget_hide(CanvasGW);
  else gtk_widget_show(CanvasGW);
}

static void cb_vg(GtkAction *action, gpointer user_data){
  static gboolean ok = TRUE;
  ok  = !ok;
  if(ok) gtk_widget_hide(CanvasVG);
  else gtk_widget_show(CanvasVG);
}

static void cb_p1(GtkAction *action, gpointer user_data){
  static gboolean ok = FALSE;
  ok  = !ok;
  if(ok) gtk_widget_hide(Parameters);
  else gtk_widget_show(Parameters);
}

static void cb_p2(GtkAction *action, gpointer user_data){
  static gboolean ok = FALSE;
  ok  = !ok;
  if(ok) gtk_widget_hide(Parameters2);
  else gtk_widget_show(Parameters2);
}

static void cb_axes(GtkAction *action, gpointer user_data){
  static gboolean ok = TRUE;
  ok  = !ok;
  if(ok) gtk_widget_hide(Axes);
  else gtk_widget_show(Axes);
}

static GtkToggleActionEntry t_entries[] = {
  {"param1", NULL, "param1", NULL, NULL, G_CALLBACK(cb_p1), TRUE},
  {"param2", NULL, "param2", NULL, NULL, G_CALLBACK(cb_p2), TRUE},
  {"axes", NULL, "axes", NULL, NULL, G_CALLBACK(cb_axes), FALSE},
  {"w-k", NULL, "w-k", NULL, NULL, G_CALLBACK(cb_wk), TRUE},
  {"g-k", NULL, "g-k", NULL, NULL, G_CALLBACK(cb_gk), FALSE},
  {"g-w", NULL, "g-w", NULL, NULL, G_CALLBACK(cb_gw), FALSE},
  {"vg-k", NULL, "vg-k", NULL, NULL, G_CALLBACK(cb_vg), FALSE},
};

static guint n_t_entries = G_N_ELEMENTS(t_entries);

static GtkUIManager* create_menu(GtkWidget *parent){
  GtkUIManager *ui;
  GtkActionGroup *actions;
  ui = gtk_ui_manager_new();
  actions = gtk_action_group_new("menu");
  gtk_action_group_add_actions(actions, entries, sizeof(entries)/sizeof(entries[0]), parent);
  gtk_action_group_add_toggle_actions(actions, t_entries, n_t_entries, NULL);
  gtk_ui_manager_insert_action_group(ui, actions, 0);
  gtk_ui_manager_add_ui_from_string(ui, menu_info, -1, NULL);
  gtk_window_add_accel_group(GTK_WINDOW(parent), gtk_ui_manager_get_accel_group(ui));
  return ui;
}

GtkWidget *parameters2_new(void){
  GtkWidget *w,*e;
  w = gtk_table_new(5,4, TRUE);
  e = gtk_label_new("wc");
  gtk_table_attach(GTK_TABLE(w), e, 0, 1,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Ewc = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Ewc, 1, 2,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("cv");
  gtk_table_attach(GTK_TABLE(w), e, 2, 3,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Ecv = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Ecv, 3, 4,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("theta");
  gtk_table_attach(GTK_TABLE(w), e, 0, 1,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Etheta = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Etheta, 1, 2,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("xcs");
  gtk_table_attach(GTK_TABLE(w), e, 0, 1, 2, 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Excs = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Excs, 1, 2,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("xcl");
  gtk_table_attach(GTK_TABLE(w), e, 2, 3,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Excl = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Excl, 3, 4,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("cxi");
  gtk_table_attach(GTK_TABLE(w), e, 0, 1,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Ecxi = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Ecxi, 1, 2,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("cxa");
  gtk_table_attach(GTK_TABLE(w), e, 2, 3,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Ecxa = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Ecxa, 3, 4,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("cyi");
  gtk_table_attach(GTK_TABLE(w), e, 0, 1,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Ecyi = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Ecyi, 1, 2,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  e = gtk_label_new("cya");
  gtk_table_attach(GTK_TABLE(w), e, 2, 3,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  Ecya = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(w), Ecya, 3, 4,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);

  return w;

}

static void cb_log(GtkAction *action, gpointer user_data){
  GtkWidget *dialog, *content, *table;
  GtkWidget *x_log_1, *x_log_2, *x_log_3; 
  GtkWidget *y_log_1, *y_log_2, *y_log_3; 
  GtkWidget *x_pos_1, *x_pos_2, *x_pos_3; 
  GtkWidget *y_pos_1, *y_pos_2, *y_pos_3;
  gboolean isLogScale, isLogScalePositive;
  GtkWidget *button;
  gint response;
  dialog = gtk_dialog_new_with_buttons("Change the number of particles", GTK_WINDOW(Window), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK,\
    GTK_RESPONSE_OK);
  //content = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  content = ((GtkDialog*) dialog)->vbox;
  table = gtk_table_new(5,5,TRUE);
  gtk_box_pack_start(GTK_BOX(content), table, FALSE, FALSE ,1);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("X"), 1, 3,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("Y"), 3, 5,0 , 1, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("log"), 1, 2,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("positive"), 2, 3,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("log"), 3, 4,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("positive"), 4, 5,1 , 2, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("w-k"), 0, 1,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("g-k"), 0, 1,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), gtk_label_new("g-w"), 0, 1,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  x_log_1 = gtk_check_button_new();
  x_pos_1 = gtk_check_button_new();
  getLogscale(CanvasWK, &isLogScale, &isLogScalePositive, 1);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_log_1), isLogScale);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_pos_1), isLogScalePositive);
  gtk_table_attach(GTK_TABLE(table), x_log_1, 1, 2,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), x_pos_1, 2, 3,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  y_log_1 = gtk_check_button_new();
  y_pos_1 = gtk_check_button_new();
  getLogscale(CanvasWK, &isLogScale, &isLogScalePositive, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(y_log_1), isLogScale);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(y_pos_1), isLogScalePositive);
  gtk_table_attach(GTK_TABLE(table), y_log_1, 3, 4,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), y_pos_1, 4, 5,2 , 3, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  x_log_2 = gtk_check_button_new();
  x_pos_2 = gtk_check_button_new();
  getLogscale(CanvasGK, &isLogScale, &isLogScalePositive, 1);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_log_2), isLogScale);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_pos_2), isLogScalePositive);
  gtk_table_attach(GTK_TABLE(table), x_log_2, 1, 2,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), x_pos_2, 2, 3,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  y_log_2 = gtk_check_button_new();
  y_pos_2 = gtk_check_button_new();
  getLogscale(CanvasGK, &isLogScale, &isLogScalePositive, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(y_log_2), isLogScale);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(y_pos_2), isLogScalePositive);
  gtk_table_attach(GTK_TABLE(table), y_log_2, 3, 4,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), y_pos_2, 4, 5,3 , 4, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  x_log_3 = gtk_check_button_new();
  x_pos_3 = gtk_check_button_new();
  getLogscale(CanvasGW, &isLogScale, &isLogScalePositive, 1);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_log_3), isLogScale);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_pos_3), isLogScalePositive);
  gtk_table_attach(GTK_TABLE(table), x_log_3, 1, 2,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), x_pos_3, 2, 3,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  y_log_3 = gtk_check_button_new();
  y_pos_3 = gtk_check_button_new();
  getLogscale(CanvasGW, &isLogScale, &isLogScalePositive, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(y_log_3), isLogScale);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(y_pos_3), isLogScalePositive);
  gtk_table_attach(GTK_TABLE(table), y_log_3, 3, 4,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);
  gtk_table_attach(GTK_TABLE(table), y_pos_3, 4, 5,4 , 5, GTK_FILL|GTK_SHRINK|GTK_EXPAND, GTK_FILL|GTK_SHRINK|GTK_EXPAND, 0, 0);

  gtk_widget_show_all(content);
  while(1){
    response = gtk_dialog_run(GTK_DIALOG(dialog));
    if(response == GTK_RESPONSE_OK){
      isLogScale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x_log_1));
      isLogScalePositive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x_pos_1));
      setLogscale(CanvasWK, isLogScale, isLogScalePositive, 1);
      isLogScale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(y_log_1));
      isLogScalePositive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(y_pos_1));
      setLogscale(CanvasWK, isLogScale, isLogScalePositive, 0);
      isLogScale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x_log_2));
      isLogScalePositive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x_pos_2));
      setLogscale(CanvasGK, isLogScale, isLogScalePositive, 1);
      isLogScale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(y_log_2));
      isLogScalePositive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(y_pos_2));
      setLogscale(CanvasGK, isLogScale, isLogScalePositive, 0);
      isLogScale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x_log_3));
      isLogScalePositive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x_pos_3));
      setLogscale(CanvasGW, isLogScale, isLogScalePositive, 1);
      isLogScale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(y_log_3));
      isLogScalePositive = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(y_pos_3));
      setLogscale(CanvasGW, isLogScale, isLogScalePositive, 0);
      break;
    }
  }

  gtk_widget_destroy(dialog);
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);
}
int main(int argc, char *argv[]){

  gtk_init(&argc, &argv);
  set_color();
  param = (parameter *) malloc(sizeof(parameter)*5);

  Window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  g_signal_connect(G_OBJECT(Window), "destroy", G_CALLBACK(destroy), NULL);

  Vbox = gtk_vbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(Window), Vbox);

  {
    GtkUIManager *ui;
    GtkWidget *menubar;
    ui = create_menu(Window);
    menubar = gtk_ui_manager_get_widget(ui, "/Menubar");
    gtk_box_pack_start(GTK_BOX(Vbox), menubar, FALSE, FALSE, 1);

    Parameters = parameters_new(5);
    gtk_box_pack_start(GTK_BOX(Vbox), Parameters, FALSE, FALSE, 1);
    Parameters2 = parameters2_new();
    gtk_box_pack_start(GTK_BOX(Vbox), Parameters2, FALSE, FALSE, 1);
    Axes = axes_new();
    gtk_box_pack_start(GTK_BOX(Vbox), Axes, FALSE, FALSE, 1);
  }
  {
    CanvasWK = my_graph();
    gtk_widget_set_size_request(CanvasWK,300, 100);
    set_xrange(CanvasWK, 0, 1);
    set_yrange(CanvasWK, 0, 1);
    set_xlabel(CanvasWK, "k");
    set_ylabel(CanvasWK, "ω");
    gtk_box_pack_start(GTK_BOX(Vbox),  CanvasWK, TRUE, TRUE, 1);
    CanvasGK = my_graph();
    gtk_widget_set_size_request(CanvasGK,300, 100);
    set_xrange(CanvasGK, 0, 1);
    set_yrange(CanvasGK, 0, 1);
    set_xlabel(CanvasGK, "k");
    set_ylabel(CanvasGK, "γ");
    gtk_box_pack_start(GTK_BOX(Vbox),  CanvasGK, TRUE, TRUE, 1);
    CanvasGW = my_graph();
    gtk_widget_set_size_request(CanvasGW,300, 100);
    set_xrange(CanvasGW, 0, 1);
    set_yrange(CanvasGW, 0, 1);
    set_xlabel(CanvasGW, "ω");
    set_ylabel(CanvasGW, "γ");
    gtk_box_pack_start(GTK_BOX(Vbox),  CanvasGW, TRUE, TRUE, 1);
    CanvasVG = my_graph();
    gtk_widget_set_size_request(CanvasVG,300, 100);
    set_xrange(CanvasVG, 0, 1);
    set_yrange(CanvasVG, 0, 1);
    set_xlabel(CanvasVG, "k");
    set_ylabel(CanvasVG, "vg");
    gtk_box_pack_start(GTK_BOX(Vbox),  CanvasVG, TRUE, TRUE, 1);

  }

  gtk_widget_show_all(Window);
  gtk_widget_hide(Axes);
  gtk_widget_hide(CanvasGK);
  gtk_widget_hide(CanvasGW);
  gtk_widget_hide(CanvasVG);
  gtk_main();
  return 0;

}

