#include <gtk/gtk.h>
#include <stdlib.h>
#include <complex.h>
#include <math.h>
#include "graph.h"
#include <gtdispc.h> 
#include "state.h"

GtkWidget *MAIN2 = NULL;
GtkWidget *CanvasWK, *CanvasGK, *CanvasGW;
GtkWidget *R_frmin, *R_frmax, *R_fimin, *R_fimax, *R_kmin, *R_kmax;

GtkWidget *Label_max;
char label_max_text[1001];
GtkWidget *POL_BUTTON;

double normal_x = 1, normal_y = 1;

MAIN2S main2s;

typedef struct{
  GtkWidget* pol_radio, *del_radio;
}MAIN2W;
MAIN2W main2w;

static void set_graph(void);

static void cb_mode_del(GtkWidget *canvas, gpointer p){
  main2s.click = CLICK_DEL;
}

static void cb_mode_pol(GtkWidget *canvas, gpointer p){
  main2s.click = CLICK_INFO;
}

static int line_num;
static gboolean cb_button_press_event(GtkWidget *canvas, GdkEventButton *event, gpointer p){
  double distance = DBL_MAX;
  int index_line = -1;
  // should be fixed
  for(int i =0;i < ans;i++){
    double d = DBL_MAX;
    dcurve *ddd = DCURVE + i;
    if(ddd->isVisible){
      double *x, *y;
      if(canvas == CanvasWK){
        x = ddd->k;
        y = ddd->w;
      }else if(canvas == CanvasGK){
        x = ddd->k;
        y = ddd->g;
      }else{
        x = ddd->k;
        y = ddd->w;
      }
      for(int j = 0; j < ddd->length;j++){
        double dd;
        dd = sqrt(pow(*(x +j) - xclicked, 2) + pow(*(y + j) - yclicked,2));
        d = dd < d ? dd : d;
      }
      if(distance > d){
        distance = d;
        index_line = i;
      }
    }
  }

  if(index_line >= 0 && main2s.click == CLICK_DEL){
    dcurve *curve = DCURVE + index_line;
    curve->isVisible = FALSE;
    set_graph();
  }else if(index_line >= 0 && main2s.click == CLICK_INFO){
    if(main2s.selected_line != -1){
      if(event->button == 3){
        dcurve *curve;
        curve = DCURVE + line_num;
        clear_circle(CanvasWK);
        clear_circle(CanvasGK);
        clear_circle(CanvasGW);
        main2s.selected_line = -1;
        set_graph();
      }
      else{
        if(!MAIN3)MAIN3 =  main3_new();
        int index;
        gchar text[32];
        snprintf(text, 31,"w = %e", yclicked);
        gtk_label_set_text(GTK_LABEL(wlabel),text);
        snprintf(text, 31,"k = %e", xclicked);
        gtk_label_set_text(GTK_LABEL(klabel),text);
        // find correspoding index
        index = 199;
        if(xclicked <= *(rrr[index_line])) index;
        else{
          for(int i = 1; i<200;i++){
            if(*(rrr[index_line] + i) == -DBL_MAX){
              index = i-1;
              break;
            }
            if(*(rrr[index_line]+i) > xclicked){
              index = i-1;
              break;
            }
          }
        }
        main3_set_E(*(eee_x[index_line]+index), *(eee_y[index_line]+index), *(eee_z[index_line]+index), *(fff[index_line]+index));
        gtk_widget_queue_draw(MAIN3);
        gtk_widget_show_all(MAIN3);

      }
    }else{
      main2s.selected_line = index_line;
      double max_g, cor_w, cor_k;
      int index;
      index = (DCURVE+index_line)->max_g;
      max_g = *((DCURVE+index_line)->g +index);
      cor_w = *((DCURVE+index_line)->w +index);
      cor_k = *((DCURVE+index_line)->k +index);

      snprintf(label_max_text, 1000, "Maximum growth rate <i>&#969;</i><sub>i</sub> = %e  @ <i>k</i> = %e, <i>&#969;</i><sub>r</sub> = %e", max_g, cor_k, cor_w);
      gtk_label_set_markup(GTK_LABEL(Label_max), label_max_text);

      line_num = index_line;
      set_graph();
    }
  }
      gtk_widget_queue_draw(CanvasWK);
      gtk_widget_queue_draw(CanvasGK);
      gtk_widget_queue_draw(CanvasGW);

  return FALSE;
}
static void cb_destroy(GtkWidget *w, gpointer p){
  gtk_widget_destroy(w);
  MAIN2 = NULL;
}

static void cb_destroy_button(GtkWidget *button, gpointer p){
  g_free(g_object_get_data(G_OBJECT(button), "index"));
}

static void cb_toggled(GtkWidget *button, gpointer p){
  gint *index;
  gboolean active;
  dcurve *curve;
  index = (gint*) g_object_get_data(G_OBJECT(button), "index");
  active = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button));
  curve = DCURVE + *index;
  if(active) curve->isVisible = TRUE;
  else curve->isVisible = FALSE;
  set_graph();
}

void clear_figures(){
  clear_line(CanvasWK);
  clear_line(CanvasGK);
  clear_line(CanvasGW);
  clear_circle(CanvasWK);
  clear_circle(CanvasGK);
  clear_circle(CanvasGW);
  
  for(int i = 0;i < ans; i++){
    reset_dcurve_graphs(DCURVE+i);
  }
}

void reset_dcurve_graphs(dcurve *d){
  GList *list;
  list = d->lines;
  while(list){
    g_free(list->data);
    list = g_list_next(list);
  };
  g_list_free(d->lines);
  d->lines = NULL;

}

void append_curve(dcurve *curve, double *w, double *g, double *k, int length, double red, double green, double blue){
  int i, j, kk, *d;
  i = append_line(CanvasWK, k, w, length, red, green, blue);
  j = append_line(CanvasGK, k, g, length, red, green, blue);
  kk = append_line(CanvasGW, w, g, length, red, green, blue);
  if(!curve->isVisible){
    hide_line(CanvasWK, i);
    hide_line(CanvasGK, j);
    hide_line(CanvasGW, kk);
  }
  d = (int *) g_malloc(sizeof(int)*3);
  *d = i;
  *(d+1) = j;
  *(d+2) = kk;
  curve->lines = g_list_append(curve->lines, (gpointer) d);
}

static void set_graph(void){
  clear_figures();
  double f[200], g[200];
  double k[200];
  int length;
  double pol;
  int before_j;

  
  if(main2s.line == LINE_POL){
    for(int i = 0; i < ans; i++){
      length = 200;
      dcurve * curve = DCURVE + i;
      for(int j = 0; j < 200; j++)
        if(*(rrr[i] + j) != -DBL_MAX){
          f[j] = creal(*(fff[i] + j))/normal_y;
          g[j] = cimag(*(fff[i] + j))/normal_y;
          k[j] = *(rrr[i] + j)/normal_x;
        }else{
          length = j;
          break;
        }
      pol = *polarity[i];
      before_j = 0;
      for(int j = 1; j < length; j++){
        if((*(polarity[i] + j) * pol) <= 0){
          if(pol < 0){
            append_curve(curve, f+before_j, g + before_j, k + before_j, j - before_j, 1, 0, 0);
            pol = *(polarity[i] + j);
          }else{
            append_curve(curve, f+before_j, g + before_j, k + before_j, j - before_j, 0, 0, 1);
            pol = *(polarity[i] + j);
          }
          before_j = j;
        }
      }
      if(pol < 0){
        append_curve(curve, f+before_j, g + before_j, k + before_j, length - before_j, 1, 0, 0);
      }else{
        append_curve(curve, f+before_j, g + before_j, k + before_j, length - before_j, 0, 0, 1);
      }
    }
  }else{
    for(int i = 0;i < ans;i++){
      dcurve *curve = DCURVE + i;
      if(i != main2s.selected_line){
        append_curve(curve, curve->w, curve->g, curve->k, curve->length, curve->color_r, curve->color_g, curve->color_b);
      }else{
        append_curve(curve, curve->w, curve->g, curve->k, curve->length, 1, 0, 0);
      }
    }
  }

  if(main2s.click == CLICK_INFO && main2s.selected_line > -1){
      double max_g, cor_w, cor_k;
      int index, index_line;
      index_line = main2s.selected_line;
      index = (DCURVE+index_line)->max_g;
      max_g = *((DCURVE+index_line)->g +index);
      cor_w = *((DCURVE+index_line)->w +index);
      cor_k = *((DCURVE+index_line)->k +index);
      add_circle(CanvasWK, cor_k, cor_w, 3, 0, 0, 0);
      add_circle(CanvasGK, cor_k, max_g, 3, 0, 0, 0);
      add_circle(CanvasGW, cor_w, max_g, 3, 0, 0, 0);
  }
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);
}

static void cb_pol(GtkWidget *button, GtkWindow *window){
  gboolean is_pol_on;
  double f[200], g[200];
  double r[200];
  int length;
  int pol;
  int before_j;

  is_pol_on = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button));
  if(is_pol_on)main2s.line = LINE_POL;
  else main2s.line = LINE_NORMAL;
  set_graph();
}

static void cb_normalize(GtkWidget *widget, GtkWindow *window){
  GtkWidget *dialog, *hbox, *vbox;
  gint response;

  dialog = gtk_dialog_new_with_buttons("NORMALIZE", window, GTK_DIALOG_MODAL, GTK_STOCK_OK, GTK_RESPONSE_OK, NULL);
  vbox = GTK_DIALOG(dialog)->vbox;
  gchar text[4];
  GtkWidget *button, *label, *combow, *combok, *combor, *combos;
  hbox = gtk_hbox_new(TRUE, 3);

  gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
  label = gtk_label_new("ω/");
  gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
  combow = gtk_combo_box_new_text();
  gtk_box_pack_start_defaults(GTK_BOX(hbox), combow);
  gtk_combo_box_append_text(GTK_COMBO_BOX(combow), "1");
  gtk_combo_box_append_text(GTK_COMBO_BOX(combow), "Ω");
  gtk_combo_box_append_text(GTK_COMBO_BOX(combow), "Π");
  gtk_combo_box_set_active(GTK_COMBO_BOX(combow), 0);

  hbox = gtk_hbox_new(TRUE, 3);
  gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
  combok = gtk_combo_box_new_text();
  gtk_box_pack_start_defaults(GTK_BOX(hbox), combok);
  gtk_combo_box_append_text(GTK_COMBO_BOX(combok), "k");
  gtk_combo_box_append_text(GTK_COMBO_BOX(combok), "k||");
  gtk_combo_box_append_text(GTK_COMBO_BOX(combok), "k｜");
  gtk_combo_box_set_active(GTK_COMBO_BOX(combok), 0);
  label = gtk_label_new("*");
  gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
  combor = gtk_combo_box_new_text();
  gtk_box_pack_start_defaults(GTK_BOX(hbox), combor);
  gtk_combo_box_append_text(GTK_COMBO_BOX(combor), "1");
  gtk_combo_box_append_text(GTK_COMBO_BOX(combor), "ρ");
  gtk_combo_box_set_active(GTK_COMBO_BOX(combor), 0);

  hbox = gtk_hbox_new(TRUE, 3);
  gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
  combos = gtk_combo_box_new_text();
  gtk_box_pack_start_defaults(GTK_BOX(hbox), combos);
  for(int i = 0; i < num; i++){
    gchar text[25];
    snprintf(text, 24, "%d:%s", i+1, *(sname + i));
    gtk_combo_box_append_text(GTK_COMBO_BOX(combos), text);
  }
  gtk_combo_box_set_active(GTK_COMBO_BOX(combos), 0);


  gtk_widget_show_all(dialog);
  response = gtk_dialog_run(GTK_DIALOG(dialog));
  if ( response == GTK_RESPONSE_OK){
    int ispecies;
    gchar* text, *ktext, *wtext, *rtext;
    text = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combos));
    ispecies = atoi(text) -1;
    g_free(text);

    normal_x = 1;
    text = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combok));
    if(!g_strcmp0(text, "k")) ktext = "k";
    else if(!g_strcmp0(text, "k||")){
      normal_x = cos(theta/180*M_PI);
      ktext =  "k||";
    }else{
      normal_x = sin(theta/180*M_PI);
      ktext = "k|";
    }
    g_free(text);
    text = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combor));
    if(!g_strcmp0(text, "1")) ktext = g_strdup_printf("%s", ktext);
    else if(!g_strcmp0(text, "ρ")){
      normal_x *= fabs(*(peth + ispecies)/b/ *(qm + ispecies));
      if(*(loss0 + ispecies) == 1){
        double rho, beta;
        rho = *(ppp + ispecies);
        beta = *(bfac + ispecies);
        normal_x *= sqrt( (1-rho*beta*beta)/(1-rho*beta));
      }
      ktext = g_strdup_printf("%sρ(%s)", ktext, *(sname + ispecies));
    }
    normal_x = 1/normal_x;
    g_free(text);
    set_xlabel(CanvasWK, ktext);
    set_xlabel(CanvasGK, ktext);
    g_free(ktext);
    
    normal_y = 1;
    text = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combow));
    gchar *temp;
    if(!g_strcmp0(text, "1")) temp = "1";// nothing
    else if(!g_strcmp0(text, "Ω")){
      normal_y = fabs(b* *(qm + ispecies));
      temp = "Ω";
    }else if(!g_strcmp0(text, "Π")){
      normal_y = *(wp + ispecies);
      temp = "Π";
    }
    g_free(text);
    wtext = g_strdup_printf("ω/%s(%s)", temp, *(sname + ispecies));
    rtext = g_strdup_printf("γ/%s(%s)", temp, *(sname + ispecies));
    set_ylabel(CanvasWK, wtext);
    set_ylabel(CanvasGK, rtext);
    set_xlabel(CanvasGW, wtext);
    set_ylabel(CanvasGW, rtext);
    g_free(wtext);
    g_free(rtext);

    double kmin, kmax, wmin, wmax, rmin, rmax;
    kmin = init_state.kmin/normal_x;
    kmax = init_state.kmax/normal_x;
    wmin = init_state.wmin/normal_y;
    wmax = init_state.wmax/normal_y;
    rmin = init_state.rmin/normal_y;
    rmax = init_state.rmax/normal_y;
    set_xrange(CanvasWK, kmin, kmax);
    set_xrange(CanvasGK, kmin, kmax);
    set_xrange(CanvasGW, wmin, wmax);
    set_yrange(CanvasWK, wmin, wmax);
    set_yrange(CanvasGK, rmin, rmax);
    set_yrange(CanvasGW, rmin, rmax);
    gchar text2[21];
    snprintf(text2, 20, "%e", wmin);
    gtk_entry_set_text(GTK_ENTRY(R_frmin), text2);
    snprintf(text2, 20, "%e", wmax);
    gtk_entry_set_text(GTK_ENTRY(R_frmax), text2);
    snprintf(text2, 20, "%e", rmin);
    gtk_entry_set_text(GTK_ENTRY(R_fimin), text2);
    snprintf(text2, 20, "%e", rmax);
    gtk_entry_set_text(GTK_ENTRY(R_fimax), text2);
    snprintf(text2, 20, "%e", kmin);
    gtk_entry_set_text(GTK_ENTRY(R_kmin), text2);
    snprintf(text2, 20, "%e", kmax);
    gtk_entry_set_text(GTK_ENTRY(R_kmax), text2);
    
  }
  gtk_widget_destroy(dialog);
  set_graph();
}

static void cb_lines(GtkWidget *widget, GtkWindow *window){
  GtkWidget *dialog, *hbox, *vbox;
  gint response;

  show_numbers(CanvasWK, TRUE);
  show_numbers(CanvasGK, TRUE);
  show_numbers(CanvasGW, TRUE);
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);

  dialog = gtk_dialog_new_with_buttons("LINES", window, GTK_DIALOG_MODAL, GTK_STOCK_CANCEL, GTK_RESPONSE_OK, NULL);
  vbox = GTK_DIALOG(dialog)->vbox;
  for(int i = 0; i<ans; i++){
    gchar text[4];
    GtkWidget *button;
    gint *data;
    if(i%5 == 0){
      hbox = gtk_hbox_new(TRUE, 3);
      gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
    }
    snprintf(text, 3, "%d", i);
    button = gtk_check_button_new_with_label(text);
    data = (gint *)g_malloc0(sizeof(gint));
    *data = i;
    g_object_set_data(G_OBJECT(button), "index", data);
    if(graph_is_visible(CanvasWK, i)) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
    else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
    g_signal_connect(G_OBJECT(button), "destroy", G_CALLBACK(cb_destroy_button), NULL);
    g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(cb_toggled), NULL);
    gtk_box_pack_start_defaults(GTK_BOX(hbox), button);
  }

  gtk_widget_show_all(dialog);
  response = gtk_dialog_run(GTK_DIALOG(dialog));
  if ( response == GTK_RESPONSE_ACCEPT){
  }
  gtk_widget_destroy(dialog);
  show_numbers(CanvasWK, FALSE);
  show_numbers(CanvasGK, FALSE);
  show_numbers(CanvasGW, FALSE);
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);
}
/*
static void cb_output2(GtkWidget *widget, GtkWindow *window){
  GtkWidget *dialog;
  gint response;
  dialog = gtk_file_chooser_dialog_new("Save data", GTK_WINDOW(window), GTK_FILE_CHOOSER_ACTION_SAVE,\
    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, NULL);
  gtk_widget_show_all(dialog);
  response = gtk_dialog_run(GTK_DIALOG(dialog));
  if ( response == GTK_RESPONSE_ACCEPT){
    gchar *filename;
    filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
    FILE *fp;
    fp = fopen(filename, "w");
    if(fp){
      for(int i = 0;i < ans; i++){
        if(graph_is_visible(CanvasWK, i)){
          for(int j = 0; j < 200; j++){
            complex fct1, fct2;
            if(*(rrr[i] + j) == -DBL_MAX) break;
            fct1 = fabs(wc)/(*(fff[i] + j));
            fct2 = fct1*fct1;
            fprintf(fp, "%e %e ", creal(*(ddd1[i] + j)), cimag(*(ddd1[i] + j)));
            fprintf(fp, "%e %e ", creal(*(ddd2[i] + j)*fct1), cimag(*(ddd2[i] + j)*fct1));
            fprintf(fp, "%e %e ", creal(*(ddd3[i] + j)*fct1), cimag(*(ddd3[i] + j)*fct1));
            fprintf(fp, "%e %e ", creal(*(ddd4[i] + j)*fct2), cimag(*(ddd4[i] + j)*fct2));
            fprintf(fp, "%e %e ", creal(*(ddd5[i] + j)*fct2), cimag(*(ddd5[i] + j)*fct2));
            fprintf(fp, "%e %e\n", creal(*(ddd6[i] + j)*fct2), cimag(*(ddd6[i] + j)*fct2));
          }
          fprintf(fp, "\n");
        }
      }
      fclose(fp);
    }else{
      g_message("Failed to save");
    }
  }
  gtk_widget_destroy(dialog);
}
*/

static void cb_output(GtkWidget *widget, GtkWindow *window){
  GtkWidget *dialog;
  gint response;
  dialog = gtk_file_chooser_dialog_new("Save data", GTK_WINDOW(window), GTK_FILE_CHOOSER_ACTION_SAVE,\
    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, NULL);
  gtk_widget_show_all(dialog);
  response = gtk_dialog_run(GTK_DIALOG(dialog));
  if ( response == GTK_RESPONSE_ACCEPT){
    gchar *filename;
    filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
    FILE *fp;
    fp = fopen(filename, "w");
    if(fp){
      for(int i = 0;i < ans; i++){
        if(graph_is_visible(CanvasWK, i)){
          for(int j = 0; j < 200; j++){
            if(*(rrr[i] + j) == -DBL_MAX) break;
            complex fct1, fct2;
            fprintf(fp, "%e\t%e\t%e\t", *(rrr[i] + j)/normal_x, creal(*(fff[i] + j))/normal_y, cimag(*(fff[i] + j))/normal_y);
            fct1 = fabs(wc)/(*(fff[i] + j));
            fct2 = fct1*fct1;
            fprintf(fp, "\n");////////////
            /*
            fprintf(fp, "%e\t%e\t", creal(*(ddd1[i] + j)), cimag(*(ddd1[i] + j)));
            fprintf(fp, "%e\t%e\t", creal(*(ddd2[i] + j)*fct1), cimag(*(ddd2[i] + j)*fct1));
            fprintf(fp, "%e\t%e\t", creal(*(ddd3[i] + j)*fct1), cimag(*(ddd3[i] + j)*fct1));
            fprintf(fp, "%e\t%e\t", creal(*(ddd4[i] + j)*fct2), cimag(*(ddd4[i] + j)*fct2));
            fprintf(fp, "%e\t%e\t", creal(*(ddd5[i] + j)*fct2), cimag(*(ddd5[i] + j)*fct2));
            fprintf(fp, "%e\t%e\n", creal(*(ddd6[i] + j)*fct2), cimag(*(ddd6[i] + j)*fct2));
            */
          }
          fprintf(fp, "\n");
        }
      }
      fclose(fp);
    }else{
      g_message("Failed to save");
    }
  }
  gtk_widget_destroy(dialog);
}

static void cb_reconfigure(GtkWidget *w, gpointer p){
  const gchar *text;
  double low, high;
  text  = gtk_entry_get_text(GTK_ENTRY(R_frmin));
  low = strtod(text, NULL);
  text  = gtk_entry_get_text(GTK_ENTRY(R_frmax));
  high = strtod(text, NULL);
  high = high > low ? high : low + 1;
  set_yrange(CanvasWK, low, high);
  set_xrange(CanvasGW, low, high);
  text  = gtk_entry_get_text(GTK_ENTRY(R_fimin));
  low = strtod(text, NULL);
  text  = gtk_entry_get_text(GTK_ENTRY(R_fimax));
  high = strtod(text, NULL);
  high = high > low ? high : low + 1;
  set_yrange(CanvasGK, low, high);
  set_yrange(CanvasGW, low, high);
  text  = gtk_entry_get_text(GTK_ENTRY(R_kmin));
  low = strtod(text, NULL);
  text  = gtk_entry_get_text(GTK_ENTRY(R_kmax));
  high = strtod(text, NULL);
  high = high > low ? high : low + 1;
  set_xrange(CanvasWK, low, high);
  set_xrange(CanvasGK, low, high);
  
  gtk_widget_queue_draw(CanvasWK);
  gtk_widget_queue_draw(CanvasGK);
  gtk_widget_queue_draw(CanvasGW);
}

GtkWidget * main2_new(void){
  GtkWidget *w, *vbox, *hbox;
  w = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_modal(GTK_WINDOW(w), FALSE);
  g_signal_connect(G_OBJECT(w), "destroy", G_CALLBACK(cb_destroy), NULL);

  vbox = gtk_vbox_new(TRUE, 3);
  gtk_container_add(GTK_CONTAINER(w), vbox);
  {
    GtkWidget *hbox;
    hbox = gtk_hbox_new(TRUE, 3);
    gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
    {
      CanvasWK = my_graph();
      gtk_widget_set_size_request(CanvasWK,200, 100);
      set_xrange(CanvasWK, 0, 1);
      set_yrange(CanvasWK, 0, 1);
      set_xlabel(CanvasWK, "Wavenumber k");
      set_ylabel(CanvasWK, "Real Frequency ω<sub>r</sub>");
      gtk_box_pack_start(GTK_BOX(hbox),  CanvasWK, TRUE, TRUE, 1);
      CanvasGW = my_graph();
      gtk_widget_set_size_request(CanvasGW,200, 100);
      set_xrange(CanvasGW, 0, 1);
      set_yrange(CanvasGW, 0, 1);
      set_xlabel(CanvasGW, "Real Frequency ω<sub>r</sub>");
      set_ylabel(CanvasGW, "Growth Rate ω<sub>i</sub>");
      gtk_box_pack_start(GTK_BOX(hbox),  CanvasGW, TRUE, TRUE, 1);
    }

    hbox = gtk_hbox_new(TRUE, 3);
    gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
    {
      GtkWidget *vbox;
      CanvasGK = my_graph();
      gtk_widget_set_size_request(CanvasGK,200, 100);
      set_xrange(CanvasGK, 0, 1);
      set_yrange(CanvasGK, 0, 1);
      set_xlabel(CanvasGK, "Wavenumber k");
      set_ylabel(CanvasGK, "Growth Rate ω<sub>i</sub>");
      gtk_box_pack_start(GTK_BOX(hbox),  CanvasGK, TRUE, TRUE, 1);
      vbox = gtk_vbox_new(TRUE, 3);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), vbox);
      {
        GtkWidget *hbox, *label;
        hbox = gtk_hbox_new(TRUE, 3);
        gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label), "<i>&#969;</i><sub><i>r</i> min</sub>");
        gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
        R_frmin = gtk_entry_new();
        gtk_box_pack_start_defaults(GTK_BOX(hbox), R_frmin);
        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label), "<i>&#969;</i><sub><i>r</i> max</sub>");
        gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
        R_frmax = gtk_entry_new();
        gtk_box_pack_start_defaults(GTK_BOX(hbox), R_frmax);
        hbox = gtk_hbox_new(TRUE, 3);
        gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label), "<i>&#969;</i><sub><i>i</i> min</sub>");
        gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
        R_fimin = gtk_entry_new();
        gtk_box_pack_start_defaults(GTK_BOX(hbox), R_fimin);
        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label), "<i>&#969;</i><sub><i>i</i> max</sub>");
        gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
        R_fimax = gtk_entry_new();
        gtk_box_pack_start_defaults(GTK_BOX(hbox), R_fimax);
        hbox = gtk_hbox_new(TRUE, 3);
        gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label), "<i>k</i><sub> min</sub>");
        gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
        R_kmin = gtk_entry_new();
        gtk_box_pack_start_defaults(GTK_BOX(hbox), R_kmin);
        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label), "<i>k</i><sub> max</sub>");
        gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
        R_kmax = gtk_entry_new();
        gtk_box_pack_start_defaults(GTK_BOX(hbox), R_kmax);

        *label_max_text = NULL;
        Label_max = gtk_label_new(label_max_text);
        gtk_box_pack_start_defaults(GTK_BOX(vbox), Label_max);

        hbox = gtk_hbox_new(TRUE, 3);
        gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
        {
          GtkWidget *button;
          GSList *group;
          button = gtk_button_new_with_label("APPLY\nRANGE");
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_reconfigure), NULL);
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);

          button = gtk_button_new_with_label("OUTPUT");
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_output), w);
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);

/*
          button = gtk_button_new_with_label("OUTPUT2");
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_output2), w);
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);
*/
          button = gtk_button_new_with_label("LINES");
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_lines), w);
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);

          button = gtk_button_new_with_label("NORMALIZE");
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_normalize), w);
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);

          POL_BUTTON = gtk_check_button_new_with_label("POL");
          button = POL_BUTTON;
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_pol), w);
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);

          button = gtk_radio_button_new_with_label(NULL ,"DEL");
          main2w.del_radio = button;
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);
          main2s.click = CLICK_DEL;
          main2s.line =  LINE_NORMAL;
          main2s.selected_line = -1;
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_mode_del), w);
          group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(button));
          button = gtk_radio_button_new_with_label(group, "Info");
          main2w.pol_radio = button;
          gtk_box_pack_start_defaults(GTK_BOX(hbox), button);
          g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(cb_mode_pol), w);
        }
      }
    }
  }
  gtk_widget_add_events(w, GDK_BUTTON_PRESS_MASK);
  g_signal_connect(G_OBJECT(w), "button-press-event", G_CALLBACK(cb_button_press_event), NULL);
  return w;
}

void main2_reset(GtkWidget *w){
  main2s.click = CLICK_DEL;
  main2s.line = LINE_NORMAL;
  main2s.selected_line = -1;
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(main2w.del_radio), TRUE);
  line_num = -1;
}
