static const gchar *menu_info =
"<ui>"
"  <menubar name='Menubar'>"
"    <menu name='File' action='File'>"
"      <menuitem name='Open' action='Open'/>"
"      <separator/>"
"      <menuitem name='Store' action='Store'/>"
"      <separator/>"
"      <menuitem name='Quit' action='Quit'/>"
"    </menu>"
"    <menu name='Utility' action='Utility'>"
"      <menuitem name='Parameter' action='Parameter'/>"
"    </menu>"
"    <menu name='Preference' action='Preference'>"
"    </menu>"
"  </menubar>"
"</ui>";

static GtkActionEntry entries[] = {
{"File", NULL, "_File"},
{"Open", GTK_STOCK_OPEN, "_Open", "<control>O", "Open an image",G_CALLBACK (cb_open)},
{"Store", GTK_STOCK_SAVE, "_Store","<control>S", "Store parameters",G_CALLBACK (cb_store)},
{"Quit", GTK_STOCK_QUIT, "_Quit", "<control>Q", "Quit this program",G_CALLBACK (destroy)},
{"Utility", NULL, "_Utility"},
{"Parameter", NULL, "_Parameter", "<control>P", "Show parameters",G_CALLBACK (cb_parameters)},
{"Preference", NULL, "Preference"}
};

static GtkUIManager* create_menu (GtkWidget *parent){
	GtkUIManager *ui;
	GtkActionGroup *actions;

	ui = gtk_ui_manager_new ();
	actions = gtk_action_group_new ("menu");
	gtk_action_group_add_actions (actions , entries ,sizeof (entries) / sizeof (entries[0]) , parent);
	gtk_ui_manager_insert_action_group (ui , actions , 0);
	gtk_ui_manager_add_ui_from_string (ui , menu_info , -1, NULL);
	gtk_window_add_accel_group (GTK_WINDOW (parent) ,
	gtk_ui_manager_get_accel_group (ui));
	return ui;
}

